#include <windows.h>
#include <stdio.h>
#include <vfw.h>

#include "bmpcnv.h"
#include "bitdsp.h"
#include "jpgcnv.h"
#pragma warning(disable:4996)
#define	VIDEO_TABLEMAX			7

typedef  struct { 
    DWORD	jpgsize;
    DWORD	bmpwith;
    DWORD	bmphigh;
    DWORD	bmpsize;
} JPEGFMT_INF,*PJPEGFMT_INF;

typedef struct {
	BYTE	b;
	BYTE	g;
	BYTE	r;
} BITRGBTBL,*PBITRGBTBL;

int  APIENTRY BitDispWindReset (long no);

static	long	WINAPI	Disp_BitmapProc (HWND ,UINT,WPARAM,LPARAM);
static	int		DispWndChk (HWND hWnd);
static	void	Video_Disp (HWND hWnd,LPBYTE buf);
static	void	SetBmpFile(PBYTE  bmp,int bsize) ;
static	int		Video_MonoColorSet (long no,long cno,long r,long g,long b);
static	short	redset (short ir,long rcol);
static	short	greset (short ig,long gcol);
static	short	bleset (short ib,long bcol);
static	int		bitmapedit (long no);
static void 	bitxmesh (PBYTE stbf,int xlen,int flg);
static void 	bitymesh (PBYTE stbf,int ylen,int xsize,int flg);

static	PBYTE	djpgptr[VIDEO_TABLEMAX];
static	long	djpgsize[VIDEO_TABLEMAX];
static	PBYTE	dispptr[VIDEO_TABLEMAX];
static	long	dispsize[VIDEO_TABLEMAX];
static	FARPROC	dispproc[VIDEO_TABLEMAX];
static	HWND	disphwnd[VIDEO_TABLEMAX];
static	int		wndsetsw[VIDEO_TABLEMAX];
static	PBMAP_FILE	capwbf;
static	PBMAP_FILE	cnvwbf;
static	HWND	cnvwnd;
static	CRITICAL_SECTION	BmpCnv_Critical;


extern	HDRAWDIB	hdrawdibDc;

		int		BitDispInit_Sw=0;

int APIENTRY	BitDispInit (HWND hWnd)
{
	int		i;
	int		ret;

	if (BitDispInit_Sw) return 0;
	cnvwnd = hWnd;
	capwbf = (PBMAP_FILE) VirtualAlloc(NULL,sizeof(BMAP_FILE),MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	cnvwbf = (PBMAP_FILE) VirtualAlloc(NULL,sizeof(BMAP_FILE),MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	for (i=0;i<VIDEO_TABLEMAX;i++) {
		wndsetsw[i] = 0;
		dispptr[i] = 0;
		dispsize[i] = 0;
		dispptr[i] =VirtualAlloc(NULL,ALLOC_BITMAPSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	
		djpgptr[i] = VirtualAlloc(NULL,ALLOC_JPGDATASIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
		djpgsize[i]	=	0;
	}
	BitDispInit_Sw = 1;
	InitializeCriticalSection(&BmpCnv_Critical);

	ret = JpegLib_Init();
	return 1;
}

int APIENTRY	BitDispEnd (void)
{
	int		i;
	int		ret;

	if (!BitDispInit_Sw) return 0;
	ret = JpegLib_End();
	for (i=0;i<VIDEO_TABLEMAX;i++) {
		ret = BitDispWindReset(i);
	}
	for (i=0;i<VIDEO_TABLEMAX;i++) {
		if (dispptr[i]) {
			VirtualFree( dispptr[i],0,MEM_RELEASE );
		}
		dispptr[i]	= 0;
		dispsize[i] = 0;

		if (djpgptr[i]) {
			VirtualFree( djpgptr[i],0,MEM_RELEASE );
		}
		djpgptr[i]	=	0;
		djpgsize[i]	=	0;

	}
	if (capwbf) VirtualFree( capwbf,0,MEM_RELEASE );
	if (cnvwbf) VirtualFree( cnvwbf,0,MEM_RELEASE );
	DeleteCriticalSection(&BmpCnv_Critical);

	capwbf = 0;
	BitDispInit_Sw = 0;
	return 1;
}

int  APIENTRY	BitDispWindSet (long no,HWND hWnd)
{

	if (wndsetsw[no]) return 0;
	wndsetsw[no]	=	1;
	disphwnd[no]	=	hWnd;
	dispproc[no]	=	(FARPROC) GetWindowLong (hWnd,GWL_WNDPROC);
	SetWindowLong (hWnd,GWL_WNDPROC,(LONG) Disp_BitmapProc);
	return 1;
}


int  APIENTRY BitDispWindReset (long no)
{
	HWND	hWnd;

	if (wndsetsw[no]) {
		hWnd = disphwnd[no];
		SetWindowLong (hWnd,GWL_WNDPROC,(LONG) dispproc[no]);
	}
	wndsetsw[no] = 0;
	return 1;
}

int  APIENTRY	BitMapChange(long no,DWORD colno,DWORD rcol,DWORD gcol,DWORD bcol)
{

	if (!BitDispInit_Sw) return 0;
	if (no < 0 || no > VIDEO_TABLEMAX) return 0;
	if (colno > 20) colno = 20;
	if (rcol > 20 ) rcol = 20;
	if (gcol > 20 ) gcol = 20;
	if (bcol > 20 ) bcol = 20;

	Video_MonoColorSet (no,colno,rcol,gcol,bcol);
	return 1;
}


int	APIENTRY	BitMapMeshSet (long no)
{
	int		rt;

	if (no < 0 || no > VIDEO_TABLEMAX) return 0;
	rt = bitmapedit (no);
	return 1;
}


int  APIENTRY	BitMapDisplay(long no)
{
	HWND					hWnd;
	PBYTE					pbf;

	if (!BitDispInit_Sw) return 0;
	if (no < 0 || no > VIDEO_TABLEMAX) return 0;

	pbf	=	dispptr[no];
	if (!pbf) return 0;
	hWnd = disphwnd[no];
	Video_Disp ((HWND) hWnd,pbf);
	return 1;
}



int  APIENTRY	BitMapSetMemry(long no,PBYTE Fname)
{
	// TODO: ި߯  ނǉĂB

	FILE					*infile;					/* target file */
	BITMAPFILEHEADER		head;
//	LPBITMAPINFOHEADER		pbit;
	DWORD					size;
	DWORD					gsize;
	PBYTE					pbf;
	HWND					hWnd;

	if (!BitDispInit_Sw) return 0;
	if (no < 0 || no > VIDEO_TABLEMAX) return 0;
	dispsize[no] = 0;
	pbf	=	dispptr[no];
	if (!pbf) return 0;
	hWnd = disphwnd[no];
	infile = fopen(Fname, "rb");
	if (!infile) return 0;
	gsize = fread (&head,sizeof(BITMAPFILEHEADER),1,infile);
	if (gsize) {
		if (head.bfType == 'MB') {
			size = head.bfSize - sizeof(BITMAPFILEHEADER); 
			gsize = fread (pbf,size,1,infile);
			if (gsize) {
				dispsize[no] = size;
//				Video_Disp ((HWND) hWnd,pbf);
			}
		}
	}
	fclose(infile);
	return 1;
}


int  APIENTRY	JpegFileSetMemory(long no,PBYTE Fname,PJPEGFMT_INF pjinf)
{
	// TODO: ި߯  ނǉĂB

//	LPBITMAPINFOHEADER		pbit;
	DWORD					size;
	DWORD					bmfsize;
	PBYTE					pbf;
	HWND					hWnd;
	PBYTE					jpgptr;
	HANDLE					infh;
	DWORD					jpgsize;
	BOOL					brt;
	DWORD					get_len;
	LPBITMAPINFOHEADER		pbmphdr;

	if (!BitDispInit_Sw) return 0;
	if (no < 0 || no > VIDEO_TABLEMAX) return 0;

	dispsize[no] = 0;
	pbf	=	dispptr[no];
	jpgptr	= djpgptr[no];
	if (!pbf) return 0;
	hWnd = disphwnd[no];

	infh = CreateFile (Fname,
					GENERIC_READ,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (infh == INVALID_HANDLE_VALUE) {
		return	0;
	}
	pjinf->bmphigh	= 0; 
	pjinf->bmpwith	= 0; 
	pjinf->bmpsize	= 0;
	pjinf->jpgsize	= 0;

	jpgsize	= GetFileSize(infh,0);
	djpgsize[no] = jpgsize;
	if (jpgsize) {
		brt = ReadFile (infh,jpgptr,jpgsize,&get_len,NULL);
		if (jpgsize == get_len) {
			bmfsize = Jpg_Bmp (jpgptr,jpgsize,pbf);
			if (bmfsize) {
				size = bmfsize - sizeof(BITMAPFILEHEADER);
				if (size > 0) {
					dispsize[no] = size;
					CopyMemory (pbf,pbf+sizeof(BITMAPFILEHEADER),size);
//					Video_Disp ((HWND) hWnd,pbf);
					pbmphdr = (LPBITMAPINFOHEADER) pbf;
					pjinf->bmphigh	= pbmphdr->biHeight; 
					pjinf->bmpwith	= pbmphdr->biWidth; 
					pjinf->bmpsize	= pbmphdr->biSizeImage;
					pjinf->jpgsize	= jpgsize;
				}
			}
		}
	}
	CloseHandle (infh);
	return 1;
}



int  APIENTRY	BitMapCopy (long inno,long otno)
{
	// TODO: ި߯  ނǉĂB

	PBYTE					pbf;
	HWND					hWnd;

	if (!BitDispInit_Sw) return 0;
	if (inno < 0 || inno > VIDEO_TABLEMAX) return 0;
	if (otno < 0 || otno > VIDEO_TABLEMAX) return 0;
	pbf	=	dispptr[inno];
	if (!pbf)				return 0;
	if (!dispsize[inno] )	return 0;
	dispsize[otno] =dispsize[inno] ;
	CopyMemory (dispptr[otno],dispptr[inno],dispsize[inno]);
	hWnd = disphwnd[otno];
	Video_Disp ((HWND) hWnd,pbf);
	return 1;
}


static	long WINAPI   Disp_BitmapProc (HWND		hWnd,
									   UINT		iMessage,
									   WPARAM	wParam,
									   LPARAM	lParam)

{

	HDC			hDc;
//	PAINTSTRUCT ps;
	int			widx;
	RECT		wrect;
	BITMAPINFOHEADER	vfmt;
	PBYTE		pt;
	FARPROC		Old_Proc;

	widx = DispWndChk (hWnd);
	if (widx == 0) {
		return DefWindowProc (hWnd,iMessage,wParam,lParam) ;
	}
	widx--;
	pt = dispptr[widx];
	Old_Proc = dispproc[widx];
	switch (iMessage)  {
		case	WM_USER+2222:
			GetClientRect (hWnd,&wrect);
			hDc		=	GetDC (hWnd);
			memcpy ((void*) &vfmt,pt,sizeof(BITMAPINFOHEADER));
			DrawDibDraw (hdrawdibDc,
					hDc,
					wrect.left,
					wrect.top,
					wrect.right  - wrect.left,
					wrect.bottom - wrect.top,
					(LPBITMAPINFOHEADER) &vfmt,
					pt+sizeof(BITMAPINFOHEADER),
					0,0,-1,-1,0);
			ReleaseDC(hWnd,hDc);
			return 		FALSE;
		case WM_PAINT:
			PostMessage (hWnd,WM_USER+2222,0,0);	// Triger
			break;
	}
	return  CallWindowProc ((WNDPROC) Old_Proc,hWnd,iMessage,wParam,lParam);

}

static	int	DispWndChk (HWND hWnd)
{
	int		i;

	for (i=0;i<VIDEO_TABLEMAX;i++) {
		if (hWnd == disphwnd[i]) {
			return i+1;
		}
	}
	return 0;
}

static int	Video_MonoColorSet (long no,long col,long rcol,long gcol,long bcol)
{
	LPBITMAPINFOHEADER	pfmt;
	PBITRGBTBL			prgb;
	int					ken;
	int					pos;
	WORD				rgb;
	int					bsize;
	PBYTE				pbf;
	double              fcol;
	double				w;
	double				r;
	double				g;
	double				b;
	double				r1;
	double				g1;
	double				b1;
	short				ir;
	short				ig;
	short 				ib;
		
	if (no < 0 || no > VIDEO_TABLEMAX) return 1;

	pbf = (PBYTE) dispptr[no];
	pfmt = (LPBITMAPINFOHEADER) pbf;
	prgb = (PBITRGBTBL) (pbf+sizeof(BITMAPINFOHEADER));

	if (pfmt->biBitCount < 12) return 1;     // Not 24 Bit mode
	if (pfmt->biCompression != BI_RGB) {	// Not RGB COLOR
		bsize = Get_bmtfile (cnvwnd,pfmt,pbf,(PBYTE) &cnvwbf->vfmt);
		bsize += sizeof(BITMAPINFOHEADER);
		CopyMemory (pbf,(PBYTE) &cnvwbf->vfmt,bsize);
		dispsize[no] = bsize;
	}

	ken = pfmt->biWidth * pfmt->biHeight;
	if (col < 11) {
		//  [hݒ
		fcol = (double) col / 10.0;

		for (pos = 0 ;pos <ken;pos++ ){
			rgb = (WORD) prgb->r +	(WORD) prgb->g + (WORD)prgb->b;
			w = (double) ((int) rgb) / 3.0;		// ϒl
			r =  w - (double) ((int) prgb->r);
			g =  w - (double) ((int) prgb->g);
			b =  w - (double) ((int) prgb->b);
			r1 = w - r * fcol;
			g1 = w - g * fcol;
			b1 = w - b * fcol;
			if (r1 < 0.0) ir = 0;	else ir = (short) r1;
			if (g1 < 0.0) ig = 0;	else ig = (short) g1;
			if (b1 < 0.0) ib = 0;	else ib = (short) b1;
			ir = redset (ir,rcol);
			ig = greset (ig,gcol);
			ib = bleset (ib,bcol);
			prgb->r = LOBYTE (ir);	
			prgb->g = LOBYTE (ig);	
			prgb->b = LOBYTE (ib);
			prgb++;
		}
	} else {
		// 邳ݒ
		fcol = (double) (col - 10) / 10.0;

		for (pos = 0 ;pos <ken;pos++ ){
			rgb = (WORD) prgb->r +	(WORD) prgb->g + (WORD)prgb->b;
			r =  (double) ((int) prgb->r);
			g =  (double) ((int) prgb->g);
			b =  (double) ((int) prgb->b);
			r1 =  r + r * fcol;
			g1 =  g + g * fcol;
			b1 =  b + b * fcol;
			if (r1 > 254.0) ir = 255;	else ir = (short) r1;
			if (g1 > 254.0) ig = 255;	else ig = (short) g1;
			if (b1 > 254.0) ib = 255;	else ib = (short) b1;
			ir = redset (ir,rcol);
			ig = greset (ig,gcol);
			ib = bleset (ib,bcol);
			prgb->r = LOBYTE (ir);	
			prgb->g = LOBYTE (ig);	
			prgb->b = LOBYTE (ib);
			prgb++;
		}
	}

	return 0;
}






static short redset (short ir,long rcol)
{
	double  cl;
	short  ans;
	if (rcol == 10) return  ir;
	else if (rcol < 10) {
		//  F
		cl = (double)rcol / 10.0; 
		ans = (short) ((double) ir * cl);
	} else {
		//  ZF
		cl = (double) (rcol - 10) / 10.0; 
		ans = (short) ((double) ir + (double) ir * cl);
		if (ans > 254) ans = 255;
	}
	return  ans;
}
static short greset (short ig,long gcol)
{
	double  cl;
	short  ans;

	if (gcol == 10) return  ig;
	else if (gcol < 10) {
		//  F
		cl = (double)gcol / 10.0; 
		ans = (short) ((double) ig * cl);
	} else {
		//  ZF
		cl = (double) (gcol - 10) / 10.0; 
		ans = (short) ((double) ig + (double) ig * cl);
		if (ans > 254) ans = 255;

	}
	return  ans;
}
static short bleset (short ib,long bcol)
{
	double  cl;
	short  ans;

	if (bcol == 10) return  ib;
	else if (bcol < 10) {
		//  F
		cl = (double)bcol / 10.0; 
		ans = (short) ((double) ib * cl);
	} else {
		//  ZF
		cl = (double) (bcol - 10) / 10.0; 
		ans = (short) ((double) ib + (double) ib * cl);
		if (ans > 254) ans = 255;

	}
	return  ans;
}


static void Video_Disp (HWND hWnd,LPBYTE buf)
{
	HDC			hDC;
	RECT		wrect;
	BITMAPINFOHEADER	vfmt;

		memcpy ((void*) &vfmt,buf,sizeof(BITMAPINFOHEADER));

		GetClientRect (hWnd,&wrect);
		hDC = GetDC (hWnd);
		DrawDibDraw (hdrawdibDc,
					hDC,
					wrect.left,
					wrect.top,
					wrect.right  - wrect.left,
					wrect.bottom - wrect.top,
					(LPBITMAPINFOHEADER) &vfmt,
					buf+sizeof(BITMAPINFOHEADER),
					0,0,-1,-1,0);

		ReleaseDC (hWnd,hDC);

}


long	bmptojpg (int qualty,PBMAP_FILE pbmp,int bsize,PBYTE jpgbf)
{
	int		bmpfsz;
	long	jpgsize;

	bmpfsz = bsize + sizeof(BITMAPINFOHEADER) + sizeof(BITMAPFILEHEADER);
	SetBmpFile ((PBYTE) pbmp,bsize);
	jpgsize = Bmp_Jpg (qualty,(PBYTE) pbmp,bmpfsz,jpgbf);
	return	jpgsize;
}




static	void SetBmpFile(PBYTE  bmp,int bsize) 
{

	LPBITMAPFILEHEADER		pbmf;
	int		size;

	pbmf = (LPBITMAPFILEHEADER) bmp;

	size = bsize+sizeof(BITMAPINFOHEADER) + sizeof(BITMAPFILEHEADER);

	pbmf->bfType	= 'MB';
	pbmf->bfOffBits =  sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	pbmf->bfSize    =  pbmf->bfOffBits + bsize;
	

}



int Get_bmtfile (HWND hwnd,LPBITMAPINFOHEADER pvfmt,PBYTE pt,LPBYTE buf)
{

	int					rtcd;
	DWORD				size;
//*****   work
	DWORD				ln;
	int					ncol;
    int                 sz;

//************ ͗p
	HDC					in_hDC;
	BITMAP				in_bm;
	HBITMAP				in_hbmp;

//************ p
	RECT				wrect;
	HDC					mem_hDC;
	HBITMAP				mem_hbmp;


//***********  bitmap aria
    LPBYTE				to_hbit;
	LPBITMAPINFOHEADER	to_bithed;
	LPRGBQUAD			to_bitcol;

	EnterCriticalSection(&BmpCnv_Critical);

	in_hDC		=	GetDC (hwnd);
//	GetClientRect	  (hwnd,&rect);
	wrect.right  = pvfmt->biWidth ;
	wrect.bottom = pvfmt->biHeight ;
	wrect.left = 0;
	wrect.top  = 0;
	in_hbmp		=	CreateCompatibleBitmap (in_hDC,wrect.right,wrect.bottom);
	GetObject  (in_hbmp,sizeof(BITMAP),(LPSTR)&in_bm);

	mem_hDC		=	CreateCompatibleDC(in_hDC);
	SetMapMode (mem_hDC,GetMapMode (in_hDC));

	mem_hbmp =  (HBITMAP) SelectObject  (mem_hDC,in_hbmp);

	DrawDibDraw (hdrawdibDc,
				mem_hDC,
				wrect.left,
				wrect.top,
				wrect.right  - wrect.left,
				wrect.bottom - wrect.top,
				(LPBITMAPINFOHEADER) pvfmt,
				pt+sizeof(BITMAPINFOHEADER),
				0,0,-1,-1,0);

	SelectObject  (mem_hDC,mem_hbmp);
	ncol = in_bm.bmPlanes * in_bm.bmBitsPixel;

	if  (ncol <= 1) {
		ncol = 1;
		sz  = 1;
    }
	else if (ncol <= 4 ) {
		ncol = 4;
		sz  = 16;
	}
	else if (ncol <= 8 ) {
		ncol = 8;
		sz  = 256;
	}
	else {
		ncol = 24;
		sz  = 1024;
	}

	memset (buf,0,sizeof(BITMAPINFOHEADER));
	to_bithed	=	(LPBITMAPINFOHEADER) buf;
	to_bitcol	=	(LPRGBQUAD) buf + sizeof(BITMAPINFOHEADER);
	if (ncol == 24) {
		ln	=	0;
		to_hbit		= (LPBYTE)	buf + sizeof(BITMAPINFOHEADER);
	}
	else {
		ln 		=	(sz * sizeof(RGBQUAD));
		(LPBYTE)to_hbit		= (LPBYTE)buf + sizeof(BITMAPINFOHEADER) + (sz * sizeof(RGBQUAD));
	}

	to_bithed->biSize	=	sizeof(BITMAPINFOHEADER);

	to_bithed->biWidth	=	in_bm.bmWidth;
	to_bithed->biHeight	=	in_bm.bmHeight;

//	to_bithed->biPlanes	=	in_bm.bmPlanes;
	to_bithed->biPlanes	=	1;
//	to_bithed->biBitCount=	in_bm.bmBitsPixel;
	to_bithed->biBitCount=	ncol;
	to_bithed->biCompression =	BI_RGB;


  	rtcd = GetDIBits ( mem_hDC,in_hbmp,0,in_bm.bmHeight,
				to_hbit,
				(LPBITMAPINFO) to_bithed,
				DIB_RGB_COLORS);

	DeleteObject (in_hbmp);
	DeleteObject (mem_hbmp);
	DeleteDC	 (mem_hDC);
	ReleaseDC    (hwnd,in_hDC);
	size = to_bithed->biSizeImage + ln;

	LeaveCriticalSection(&BmpCnv_Critical);
	return size;

}

int		Bmp_To_Jpg (long no,PBYTE jbf)
{
	BITMAPINFOHEADER	bfmt;
	int		bsize;
	int		jsize;

	if (!BitDispInit_Sw)	return 0;	// Not Open
	if (!dispsize[no])		return 0;	// Not BitMap Data
	memcpy (&bfmt,dispptr[no],sizeof(BITMAPINFOHEADER));
	if (bfmt.biWidth == 640 || bfmt.biWidth == 320 || bfmt.biWidth == 160) {
	} else {
		return	0;		//	Not Format
	}

	if (bfmt.biHeight == 480 || bfmt.biHeight == 240 || bfmt.biHeight == 120) {
	} else {
		return	0;		//	Not Format
	}
	if (bfmt.biCompression  == BI_RGB || 
		bfmt.biCompression  == '024I' ||
		bfmt.biCompression  == 'VUYI') {
	} else {
		return 0;		//	Not Support Compression
	}
	if (bfmt.biCompression  != BI_RGB) {
		bsize = Get_bmtfile (cnvwnd,(LPBITMAPINFOHEADER)&bfmt,dispptr[no],(PBYTE) &capwbf->vfmt);
		if (!bsize) return	0;
	} else {
		bsize = dispsize[no];
		CopyMemory (&capwbf->vfmt,dispptr[no],bsize);
	}
	jsize =	bmptojpg (40,capwbf,bsize,jbf);
	return	jsize;
}


int		Jpg_To_Cpy (long no,PBYTE jpgbf)
{
	if (!BitDispInit_Sw)	return 0;	// Not Open
	if (!dispsize[no])		return 0;	// Not BitMap Data
	if (!djpgptr[no])		return 0;
	if (!djpgsize[no])		return 0; 
	CopyMemory (jpgbf,djpgptr[no],djpgsize[no]);
	return  djpgsize[no];
}




static	int	 bitmapedit (long no)
{
	LPBITMAPINFOHEADER	pfmt;
	int					i,j;
	int					step;
	int					clken;
	int					bsize;
	PBYTE				pbf;
	PBYTE				pbitbf;
	PBYTE				stbf;
	int					xlngth;	
	int					bmpx;	
	int					flg;
	int					h;

	pbf		= (PBYTE) dispptr[no];
	pbitbf	= (PBYTE) (pbf+sizeof(BITMAPINFOHEADER));
	pfmt	= (LPBITMAPINFOHEADER) pbf;

	if (pfmt->biBitCount < 12) return 0;     // Not 24 Bit mode
	if (pfmt->biCompression != BI_RGB) {	// Not RGB COLOR
		bsize = Get_bmtfile (cnvwnd,pfmt,pbf,(PBYTE) &cnvwbf->vfmt);
		bsize += sizeof(BITMAPINFOHEADER);
		CopyMemory (pbf,(PBYTE) &cnvwbf->vfmt,bsize);
		dispsize[no] = bsize;
	}

//  X MESH SET

	bmpx = pfmt->biWidth*3;
	if (bmpx % 4==0) {/* obt@̂PC̒vZ */
		xlngth=bmpx;
	} else {
		xlngth=bmpx+(4-bmpx%4);
	}
	
	step	=	20;		// 20 line step
	clken	=	5;		// 5  line clear
	flg = 0;
	for (i = 0 ;i <pfmt->biHeight;i+=step ){
		stbf= pbitbf+i*xlngth;
		for (h=0;h<clken;h++) {
			bitxmesh (stbf,pfmt->biWidth,flg);
			stbf += xlngth;
		}
		flg++;
		if (flg > 7) flg =0;
	}
//  Y MESH SET
			
	step	=	40;		// 40 line step
	clken	=	5;		// 5  line clear
	flg = 0;
	for (j = 0 ;j <pfmt->biWidth;j+=step ){
		stbf= pbitbf+j*3;
		for (h=0;h<clken;h++) {
			bitymesh (stbf,pfmt->biHeight,xlngth,flg);
			stbf += 3;
		}
		flg++;
		if (flg > 7) flg =0;
	}
	return 1;
}


long	APIENTRY	BitFileDisp(long hWnd,LPCTSTR Fname) 
{
	// TODO: ި߯  ނǉĂB

	FILE					*infile;					/* target file */
	BITMAPFILEHEADER		head;
	LPBITMAPINFOHEADER		pbit;
	DWORD					hsize;
	DWORD					size;
	DWORD					gsize;
	long					rtcd;
	LPBYTE					bfpt;
	DWORD					memsize;

	memsize= 640 * 480 * 3 + 1000;
	bfpt =  VirtualAlloc(NULL,memsize,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	rtcd = 0;
	infile = fopen(Fname, "rb");
	gsize = fread (&head,sizeof(BITMAPFILEHEADER),1,infile);
	if (gsize) {
		if (head.bfType == 'MB') {
			hsize = head.bfSize - sizeof(BITMAPFILEHEADER); 
			gsize = fread (bfpt,hsize,1,infile);
			if (gsize) {
				size = head.bfSize - head.bfOffBits;
				pbit =(LPBITMAPINFOHEADER) bfpt;
				pbit->biSizeImage = size;
				Video_Disp ((HWND) hWnd,bfpt);
				rtcd = 1;
			}
		}
	}
	fclose(infile);
	VirtualFree(bfpt,0,MEM_RELEASE );
	return rtcd;
}

static void 	bitxmesh (PBYTE stbf,int xlen,int flg)
{
	int		j;

	PBITRGBTBL			prgb;

	prgb = (PBITRGBTBL) stbf;
	for (j = 0 ;j <xlen;j++ ){

		if (flg == 0) {
			prgb->r = 0;
			prgb->g = 0;
			prgb->b = 0;
		} else if (flg == 1) { 
			prgb->r = 255;
			prgb->g = 0;
			prgb->b = 0;
		} else if (flg == 2) {
			prgb->r = 0;
			prgb->g = 255;
			prgb->b = 0;
		} else if (flg == 3) {
			prgb->r = 0;
			prgb->g = 0;
			prgb->b = 255;
		} else if (flg == 4) {
			prgb->r = 255;
			prgb->g = 255;
			prgb->b = 0;
		} else if (flg == 5) {
			prgb->r = 0;
			prgb->g = 255;
			prgb->b = 255;
		} else if (flg == 6) {
			prgb->b = 255;
			prgb->g = 0;
			prgb->b = 255;
		} else {
			prgb->r = 255;
			prgb->g = 255;
			prgb->b = 255;
		}
		prgb++;
	}
	return ;
}

static void 	bitymesh (PBYTE stbf,int ylen,int xsize,int flg)
{
	int		j;

	PBITRGBTBL			prgb;

	for (j = 0 ;j <ylen;j++ ){

		prgb = (PBITRGBTBL) (stbf + j*xsize);
		if (flg == 0) {
			prgb->r = 0;
			prgb->g = 0;
			prgb->b = 0;
		} else if (flg == 1) { 
			prgb->r = 255;
			prgb->g = 0;
			prgb->b = 0;
		} else if (flg == 2) {
			prgb->r = 0;
			prgb->g = 255;
			prgb->b = 0;
		} else if (flg == 3) {
			prgb->r = 0;
			prgb->g = 0;
			prgb->b = 255;
		} else if (flg == 4) {
			prgb->r = 255;
			prgb->g = 255;
			prgb->b = 0;
		} else if (flg == 5) {
			prgb->r = 0;
			prgb->g = 255;
			prgb->b = 255;
		} else if (flg == 6) {
			prgb->b = 255;
			prgb->g = 0;
			prgb->b = 255;
		} else {
			prgb->r = 255;
			prgb->g = 255;
			prgb->b = 255;
		}
	}
	return ;
}
