
#include <windows.h>
#include <stdio.h>
#include "mapview.h"

#define	CAPDPCT_FILE_NAME	"CAPDPCT_MAPVIEW"

typedef	struct {
	int				sw;
	SYSTEMTIME		hzk;
} SDATE_TABLE,*PSDATE_TABLE;

//***************  Mutex
static	int					StartExecSw=0;
static 	HANDLE				StartExec_h=0;

static	void	drvtypmsg (DWORD drvtyp,PBYTE pwk);
static	void CanmaSet (PBYTE ibf,PBYTE obf);
//***************  create mapview
static	int					mapstsw=0;
static	PCAPDPCT_MAPVIEW	Map_View;
static	HANDLE				Map_Hndl;
static	HANDLE				File_Hndl;
static	CRITICAL_SECTION	Map_Critical;

//***************  open mapview
static	int		openmapsw=0;
static	PCAPDPCT_MAPVIEW	OpenMap_View;
static	HANDLE				OpenMap_Hndl;
static	CRITICAL_SECTION	OpenMap_Critical;

// *********** start date
static	int			date_stsw=0;
static	SDATE_TABLE  stbl[6];
static	long	date_nisu (WORD y,WORD m,WORD d);
static	void	dateset (long t,PBYTE pt);


//*******  hels
typedef		struct {
		int			exe_sw;
		HANDLE		ans_event;		// anser
		HANDLE		ext_event;		// Iʒm
		HANDLE		thread;			// Xbh̃nh
		DWORD		threadID;		// Xbhʔԍ
		} HELS_INF,*PHELS_INF;

static	 int		ctlh_start=0;	
static	 HELS_INF	ctlh_inf;
static	 BOOL	CntlHels_Thread		(PHELS_INF);

static	 int		dsph_start=0;	
static	 HELS_INF	dsph_inf;
static	 BOOL	DispHels_Thread		(PHELS_INF);



int APIENTRY	StartExec_Set (long version,long revisin)
{
	BYTE	nm[128];
	if (StartExecSw) return 1;

	wsprintf (nm,"USBLAN-VER%03d-%03d",version,revisin);
	StartExec_h = CreateMutex (0,FALSE,nm);
	ReleaseMutex (StartExec_h);
	StartExecSw = 1;
	return 0;


}
int APIENTRY	EndExec_Set ()
{
	if (StartExec_h) {
		CloseHandle (StartExec_h);
	}
	StartExec_h = 0;
	StartExecSw = 0;
	return 0;
}

int APIENTRY	Get_Exec_Mode (long version,long revisin)
{
	BYTE	nm[128];
	HANDLE	nm_h;
	wsprintf (nm,"USBLAN-VER%03d-%03d",version,revisin);

	nm_h = OpenMutex (MUTEX_ALL_ACCESS,FALSE,nm);
	if (!nm_h) {
		return 0;			// Not Found 
	}
	ReleaseMutex (nm_h);
	CloseHandle (nm_h);
	return 1;		//  Found


}


int APIENTRY	Creat_Mapview_Opn (long version,long revisin)
{
	int		bRet;
	BYTE	nm[128];

	mapstsw = 0;

	wsprintf (nm,"%s%03d-%03d",CAPDPCT_FILE_NAME,version,revisin);

	//****************************************
	//* FILE MAPPING
	//**************************************** 
	File_Hndl=(HANDLE) 0xffffffff;
	Map_Hndl = CreateFileMapping (File_Hndl,0,PAGE_READWRITE, 
								0,sizeof(CAPDPCT_MAPVIEW),nm);
	if (Map_Hndl > 0) {
			Map_View = (PCAPDPCT_MAPVIEW) MapViewOfFile (Map_Hndl,
						FILE_MAP_WRITE,0,0,0);
			memset ((void *) Map_View,0,sizeof(CAPDPCT_MAPVIEW));
			bRet = FlushViewOfFile (Map_View,0);
			InitializeCriticalSection(&Map_Critical);
			mapstsw = 1;
	}
	return 0;
}

int APIENTRY	Creat_Mapview_Cls ()
{

	if (Map_Hndl) {
		UnmapViewOfFile (Map_View);
		CloseHandle (Map_Hndl);
		Map_Hndl = 0;
		DeleteCriticalSection(&Map_Critical);

	}
	mapstsw = 0;
	return 0;

}

int APIENTRY	Mapview_Send (long no,long  dt)
{
	int		i;
	int		j;
	int		k;
	int		bRet;

	if (!mapstsw) return 1;
	EnterCriticalSection(&Map_Critical);
	i = Map_View->run[no].s_wptr;
	j = Map_View->run[no].s_rptr;
	k = i;
	Map_View->run[no].s_buf[i] = dt;
	i++;
	i = i & 0x3;
	if (i == j) j = k;
	Map_View->run[no].s_wptr = i;
	Map_View->run[no].s_rptr = j;
	bRet = FlushViewOfFile (Map_View,0);
	LeaveCriticalSection(&Map_Critical);
	return 0;
}

int APIENTRY	Mapview_Recv (long no)
{
	int		i;
	int		j;
	int		hit;
	long	dt;
	int		bRet;

	if (!mapstsw) return 1;
	EnterCriticalSection(&Map_Critical);
	i = Map_View->run[no].r_wptr;
	j = Map_View->run[no].r_rptr;
	hit = 0;
	while (i != j) {
		dt = Map_View->run[no].r_buf[j];
		hit = 1;
		j++;
		j = j & 0x3;
	}
	if (hit) {
		Map_View->run[no].r_rptr = j;
		bRet = FlushViewOfFile (Map_View,0);
	}	else {
		dt = - 1;
	}
	LeaveCriticalSection(&Map_Critical);
	return  dt;
}


int APIENTRY	Mapview_HelsSend (long no,long  dt)
{
	int		i;
	int		j;
	int		k;
	int		bRet;

	if (!mapstsw) return 1;
	EnterCriticalSection(&Map_Critical);
	i = Map_View->run[no].s_hwptr;
	j = Map_View->run[no].s_hrptr;
	k = i;
	Map_View->run[no].s_hbuf[i] = dt;
	i++;
	i = i & 0x3;
	if (i == j) j = k;
	Map_View->run[no].s_hwptr = i;
	Map_View->run[no].s_hrptr = j;
	bRet = FlushViewOfFile (Map_View,0);
	LeaveCriticalSection(&Map_Critical);
	return 0;
}

int APIENTRY	Mapview_HelsRecv (long no)
{
	int		i;
	int		j;
	int		hit;
	long	dt;
	int		bRet;

	if (!mapstsw) return 1;
	EnterCriticalSection(&Map_Critical);
	i = Map_View->run[no].r_hwptr;
	j = Map_View->run[no].r_hrptr;
	hit = 0;
	while (i != j) {
		dt = Map_View->run[no].r_hbuf[j];
		hit = 1;
		j++;
		j = j & 0x3;
	}
	if (hit) {
		Map_View->run[no].r_hrptr = j;
		bRet = FlushViewOfFile (Map_View,0);
	}	else {
		dt = - 1;
	}
	LeaveCriticalSection(&Map_Critical);
	return  dt;
}


int APIENTRY	Mapview_WrtChr (long  typ,long no,PBYTE pdt)
{
	int		bRet;
	if (!mapstsw) return 1;
	EnterCriticalSection(&Map_Critical);
	switch (typ) {
	case 0:
		lstrcpy (Map_View->data1,pdt);
		break;
	}
	bRet = FlushViewOfFile (Map_View,0);
	LeaveCriticalSection(&Map_Critical);
	return 0;
}

int APIENTRY	Mapview_GetChr (long  typ,long no,HWND ownd)
{
	if (!mapstsw) return 1;

	EnterCriticalSection(&Map_Critical);

	switch (typ) {
	case 0:
		SetWindowText (ownd,Map_View->data1);
		break;
	}
	LeaveCriticalSection(&Map_Critical);
	return 0;
}


int APIENTRY	Mapview_SetBin (long  typ,long no,long dt)
{
	int		bRet;
	if (!mapstsw) return 1;
	EnterCriticalSection(&Map_Critical);
	switch (typ) {
	case 0:
		Map_View->ken	=	 dt;
		break;
	case 1:
		Map_View->hels_time	=	 dt;
		break;
	case 2:
		Map_View->run[no].use	=	 dt;
		break;
	case 3:
		Map_View->run[no].cnt	=	 dt;
		break;
	}
	bRet = FlushViewOfFile (Map_View,0);
	LeaveCriticalSection(&Map_Critical);
	return 0;
}

int APIENTRY	Mapview_GetBin (long  typ,long no)
{
	int		ret=0;

	if (!mapstsw) return 0;
	EnterCriticalSection(&Map_Critical);
	switch (typ) {
	case 0:
		ret = Map_View->ken;
		break;
	case 1:
		ret = Map_View->hels_time;
		break;
	case 2:
		ret = Map_View->run[no].use;
		break;
	case 3:
		ret = Map_View->run[no].cnt;
		break;

	}
	LeaveCriticalSection(&Map_Critical);
	return ret;
}


int APIENTRY	Mapview_Open (long version,long revisin)
{
	BYTE	nm[128];

	if (openmapsw) return 1;

	openmapsw = 0;
	wsprintf (nm,"%s%03d-%03d",CAPDPCT_FILE_NAME,version,revisin);
	OpenMap_Hndl = OpenFileMapping( FILE_MAP_WRITE , TRUE,nm);
	if (!OpenMap_Hndl) {
		return	1;
	}
	OpenMap_View = (PCAPDPCT_MAPVIEW) MapViewOfFile (OpenMap_Hndl,
												FILE_MAP_WRITE,0,0,0);
	InitializeCriticalSection(&OpenMap_Critical);

	openmapsw = 1;
	return 0;
}

int APIENTRY	Mapview_Close (long version,long revisin)
{

	if (OpenMap_Hndl) {
		UnmapViewOfFile (OpenMap_View);
		CloseHandle (OpenMap_Hndl);
		OpenMap_Hndl = 0;
		DeleteCriticalSection(&OpenMap_Critical);

	}
	openmapsw = 0;
	return 0;
}


int APIENTRY	OpenMap_Send (long no,long  dt)
{
	int		i;
	int		j;
	int		k;
	int		bRet;

	if (!openmapsw) return 1;
	EnterCriticalSection(&OpenMap_Critical);
	i = OpenMap_View->run[no].r_wptr;
	j = OpenMap_View->run[no].r_rptr;
	k = i;
	OpenMap_View->run[no].r_buf[i] = dt;
	i++;
	i = i & 0x3;
	if (i == j) j = k;
	OpenMap_View->run[no].r_wptr = i;
	OpenMap_View->run[no].r_rptr = j;
	bRet = FlushViewOfFile (OpenMap_View,0);
	LeaveCriticalSection(&OpenMap_Critical);
	return 0;

}

int APIENTRY	OpenMap_Recv (long no)
{
	int		i;
	int		j;
	int		hit;
	long	dt;
	int		bRet;

	if (!openmapsw) return 1;
	EnterCriticalSection(&OpenMap_Critical);
	i = OpenMap_View->run[no].s_wptr;
	j = OpenMap_View->run[no].s_rptr;
	hit = 0;
	while (i != j) {
		dt = OpenMap_View->run[no].s_buf[j];
		hit = 1;
		j++;
		j = j & 0x3;
	}
	if (hit) {
		OpenMap_View->run[no].s_rptr = j;
		bRet = FlushViewOfFile (OpenMap_View,0);
	}	else {
		dt = - 1;
	}
	LeaveCriticalSection(&OpenMap_Critical);
	return  dt;

}


int APIENTRY	OpenMap_HelsSend (long no,long  dt)
{
	int		i;
	int		j;
	int		k;
	int		bRet;

	if (!openmapsw) return 1;
	EnterCriticalSection(&OpenMap_Critical);
	i = OpenMap_View->run[no].r_hwptr;
	j = OpenMap_View->run[no].r_hrptr;
	k = i;
	OpenMap_View->run[no].r_hbuf[i] = dt;
	i++;
	i = i & 0x3;
	if (i == j) j = k;
	OpenMap_View->run[no].r_hwptr = i;
	OpenMap_View->run[no].r_hrptr = j;
	bRet = FlushViewOfFile (OpenMap_View,0);
	LeaveCriticalSection(&OpenMap_Critical);
	return 0;

}

int APIENTRY	OpenMap_HelsRecv (long no)
{
	int		i;
	int		j;
	int		hit;
	long	dt;
	int		bRet;

	if (!openmapsw) return 1;
	EnterCriticalSection(&OpenMap_Critical);
	i = OpenMap_View->run[no].s_hwptr;
	j = OpenMap_View->run[no].s_hrptr;
	hit = 0;
	while (i != j) {
		dt = OpenMap_View->run[no].s_hbuf[j];
		hit = 1;
		j++;
		j = j & 0x3;
	}
	if (hit) {
		OpenMap_View->run[no].s_hrptr = j;
		bRet = FlushViewOfFile (OpenMap_View,0);
	}	else {
		dt = - 1;
	}
	LeaveCriticalSection(&OpenMap_Critical);
	return  dt;

}




int APIENTRY	OpenMap_SetBin (long  typ,long no,long dt)
{
	int		bRet;
	if (!openmapsw) return 1;

	EnterCriticalSection(&OpenMap_Critical);
	switch (typ) {
	case 0:
		OpenMap_View->ken	=	 dt;
		break;
	case 1:
		OpenMap_View->hels_time	=	 dt;
		break;
	case 2:
		OpenMap_View->run[no].use	=	dt;
		break;
	case 3:
		OpenMap_View->run[no].cnt	=	 dt;
		break;

	}
	bRet = FlushViewOfFile (OpenMap_View,0);
	LeaveCriticalSection(&OpenMap_Critical);
	return 0;
}

int APIENTRY	OpenMap_GetBin (long  typ,long no)
{
	int		ret=0;

	if (!openmapsw) return 0;
	EnterCriticalSection(&OpenMap_Critical);
	switch (typ) {
	case 0:
		ret = OpenMap_View->ken;
		break;
	case 1:
		ret = OpenMap_View->hels_time;
		break;
	case 2:
		ret = OpenMap_View->run[no].use;
		break;
	case 3:
		ret = OpenMap_View->run[no].cnt;
		break;

	}
	LeaveCriticalSection(&OpenMap_Critical);
	return ret;
}

int APIENTRY	OpenMap_WrtChr (long  typ,long no,PBYTE pdt)
{
	int		bRet;
	if (!openmapsw) return 1;

	EnterCriticalSection(&OpenMap_Critical);
	switch (typ) {
	case 0:
		lstrcpy (OpenMap_View->data1,pdt);
		break;
	}
	bRet = FlushViewOfFile (OpenMap_View,0);
	LeaveCriticalSection(&OpenMap_Critical);
	return 0;
}

int APIENTRY	OpenMap_GetChr (long  typ,long no,HWND ownd)
{
	if (!openmapsw) return 1;

	EnterCriticalSection(&OpenMap_Critical);
	switch (typ) {
	case 0:
		SetWindowText (ownd,OpenMap_View->data1);
		break;
	}
	LeaveCriticalSection(&OpenMap_Critical);
	return 0;
}

int APIENTRY	ProcExec (PBYTE fnm)
{
	int						iret;
	STARTUPINFO				stinf;
	PROCESS_INFORMATION		prcinf;

	memset ((void *) &stinf,0,sizeof(stinf));
	stinf.cb = sizeof(prcinf);
	memset ((void *) &prcinf,0,sizeof(prcinf));
	iret = CreateProcess (0,fnm,0,0,FALSE,CREATE_NEW_CONSOLE,0,0,&stinf,&prcinf);
	if (iret == 0) {
		return  0;
	}
	CloseHandle (prcinf.hThread );
	CloseHandle (prcinf.hProcess);
	return  1;
}


int APIENTRY	Date_Init (void)
{
	SYSTEMTIME nhzk;
	int			i;
	date_stsw=1;
	GetLocalTime (&nhzk);
	for (i=0;i<5;i++) {
		stbl[i].sw = 0;
		stbl[i].hzk = nhzk;
	}
	return 0;

}
int APIENTRY	Date_Start (long no,HWND dwnd)
{
	SYSTEMTIME	nhzk;
	BYTE		wk[128];
	int			i;

	if (no < 0 || no > 5) return 0;
	GetLocalTime (&nhzk);

	if (!date_stsw) {
		date_stsw = 1;
		for (i=0;i<5;i++) {
			stbl[i].sw = 1;
			stbl[i].hzk = nhzk;
		}
	} else {
		stbl[no].sw = 1;
		stbl[no].hzk = nhzk;
	}
	wsprintf (wk,"%04d/%02d/%02d %02d:%02d:%02d",
				nhzk.wYear,nhzk.wMonth,nhzk.wDay,
				nhzk.wHour,nhzk.wMinute,nhzk.wSecond);
	SetWindowText (dwnd,wk);
	return 1;
}

int APIENTRY	Date_Now (long no,HWND dwnd)
{
	SYSTEMTIME shzk; 
	SYSTEMTIME nhzk; 
	DWORD		s1;
	DWORD		s2;
	DWORD		n1;
	DWORD		n2;
	int			uru;
	long		tim1;
	long		tim2;
	long		tim;
	long		dt;
	BYTE		wk[128];

	if (no < 0 || no > 5)	return 0;
	if (!date_stsw)			return 0;
	if (!stbl[no].sw)		return 0;
	
	
	GetLocalTime (&nhzk);
	shzk = stbl[no].hzk;

	s1 = shzk.wSecond ;
	s1 = s1 + shzk.wMinute * 60 ;
	s1 = s1 + shzk.wHour * 60 * 60; 
	s2 = date_nisu (shzk.wYear,shzk.wMonth ,shzk.wDay);
	n1 = nhzk.wSecond ;
	n1 = n1 + nhzk.wMinute * 60 ;
	n1 = n1 + nhzk.wHour * 60 * 60; 
	n2 = date_nisu (nhzk.wYear,nhzk.wMonth ,nhzk.wDay);
	if (shzk.wYear == nhzk.wYear ) {
		if (n2 == s2) {
			if (n1 < s1) {
			SetWindowText (dwnd,"");
			return 0;			// ŊJnԁݎ
			}
			tim = n1 - s1;			// ŊJnԁݎ
			dateset (tim,wk);
			SetWindowText (dwnd,wk);
			return tim;
		} else if (s2 < n2) {		// NŊJnݓ
			tim = (n2 - s2) * 24 * 60 * 60;
			tim += (24 * 60 * 60) - s1;
			tim += n1;
			dateset (tim,wk);
			SetWindowText (dwnd,wk);
			return tim;
		}
		SetWindowText (dwnd,"");
		return 0;					// NŊJnݓ
	} else if (shzk.wYear < nhzk.wYear ){	// JnNݔN
		uru = shzk.wYear / 4;
		uru = shzk.wYear - uru * 4;
		if (uru) dt = 365 - s2;
		else	dt = 366 - s2;
		tim1 = dt * 24 * 60 * 60;  
		tim1 += (24 * 60 * 60) - s1;
		tim2 =  n1;
		tim2 +=  n2 * (24 * 60 * 60);
		tim = tim1 + tim2;
			dateset (tim,wk);
			SetWindowText (dwnd,wk);
		return tim;
	} 
	SetWindowText (dwnd,"");
	return 0;								// JnNݔN


}

static	long	date_nisu (WORD y,WORD m,WORD d)
{
	int		i;
	int		uru;
	long	dt;

	uru = y / 4;
	uru = y - uru * 4;
	if (m == 1) {
		return d;
	} else if (m == 2) {
		return d + 31;
	}
	dt = 0;
	for (i=1;i<m;i++) {
		if (i == 2) {
			if (uru) dt += 28;
			else	 dt += 29;
		} else if (i== 4 || i== 6 || i== 11) {
			dt += 30;
		} else {
			dt += 31;
		}
	}
	dt += d;
	return dt;
}

static void	dateset (long t,PBYTE pt)
{
	DWORD  h;
	DWORD  m;
	DWORD  s;

	s = t / 60; s = t - s * 60;
	t = t / 60;
	m = t / 60; m = t - m * 60;
	h = t / 60;
	wsprintf (pt,"%6d:%02d:%02d Sec",h,m,s);
}

int APIENTRY	CmdDate_Get (void)
{
	PBYTE	pcmd;
	PBYTE	pt;
	int		no;

	pcmd = GetCommandLine();
	pt = strstr (pcmd,"USBLAN=");
	if (!pt) return 0;
	no = atoi (pt+7);
	return  no;
}

int APIENTRY	CntlHelsGo (void)
{

	if (ctlh_start) return 0;

	ctlh_inf.ext_event	=	CreateEvent(NULL,FALSE,FALSE,NULL);		// Iʒm
	ctlh_inf.ans_event	=	CreateEvent(NULL,FALSE,FALSE,NULL);		// ĐJnʒm
	ctlh_inf.exe_sw		=	0;
	ctlh_inf.thread	=	CreateThread(
						(LPSECURITY_ATTRIBUTES) NULL,
						0,
						(LPTHREAD_START_ROUTINE) CntlHels_Thread,
						(LPVOID) &ctlh_inf,
						0,
						&ctlh_inf.threadID
						);

	WaitForSingleObject (ctlh_inf.ans_event, 5000);
	ctlh_start = 1;
	return 1;
}

int APIENTRY	CntlHelsEnd (void)
{
	if (!ctlh_start) return 0;

	SetEvent(ctlh_inf.ext_event);
	WaitForSingleObject (ctlh_inf.thread,2000);
	CloseHandle (ctlh_inf.ans_event);
	CloseHandle (ctlh_inf.ext_event);
	ctlh_start = 0;
	return 1;
}

int APIENTRY	DspHelsGo (long no)
{
	if (dsph_start) return 0;

	dsph_inf.ext_event	=	CreateEvent(NULL,FALSE,FALSE,NULL);		// Iʒm
	dsph_inf.ans_event	=	CreateEvent(NULL,FALSE,FALSE,NULL);		// ĐJnʒm
	dsph_inf.exe_sw		=	no;
	dsph_inf.thread	=	CreateThread(
						(LPSECURITY_ATTRIBUTES) NULL,
						0,
						(LPTHREAD_START_ROUTINE) DispHels_Thread,
						(LPVOID) &dsph_inf,
						0,
						&dsph_inf.threadID
						);

	WaitForSingleObject (dsph_inf.ans_event, 5000);
	dsph_start = 1;
	return 1;

}

int APIENTRY	DspHelsEnd ()
{
	if (!dsph_start) return 0;

	SetEvent(dsph_inf.ext_event);
	WaitForSingleObject (dsph_inf.thread,2000);
	CloseHandle (dsph_inf.ans_event);
	CloseHandle (dsph_inf.ext_event);
	dsph_start = 0;
	return 1;

}


static	BOOL  CntlHels_Thread (PHELS_INF tinf)

{

	HANDLE		hEvents[4];			// Cxg҂p
	int			hEventNum;			// Cxg҂p
	int			iRet;
	int			run_sw1;
	DWORD		wait_time=INFINITE;
	int			i;

	SetEvent(tinf->ans_event);		//
	run_sw1	=	TRUE;
	while (run_sw1) {
		hEvents[0]	= tinf->ext_event;	// Iʒm
		hEventNum	= 1;
		wait_time = 2000;
		iRet = WaitForMultipleObjects(hEventNum,hEvents,FALSE, wait_time);
		if(iRet == 0) {					// Iʒm
			break;
		}
		else if (iRet == WAIT_TIMEOUT) {			// ^ʒm
			int rt;

			for (i=0;i<5;i++) {
				rt = Mapview_HelsSend (i,3);
			}
		}
	}
	return	TRUE;
}

static	BOOL  DispHels_Thread (PHELS_INF tinf)

{

	HANDLE		hEvents[4];			// Cxg҂p
	int			hEventNum;			// Cxg҂p
	int			iRet;
	int			run_sw1;
	DWORD		wait_time=INFINITE;
//	int			i;

	SetEvent(tinf->ans_event);		//
	run_sw1	=	TRUE;
	while (run_sw1) {
		hEvents[0]	= tinf->ext_event;	// Iʒm
		hEventNum	= 1;
		wait_time = 2000;
		iRet = WaitForMultipleObjects(hEventNum,hEvents,FALSE, wait_time);
		if(iRet == 0) {					// Iʒm
			break;
		}
		else if (iRet == WAIT_TIMEOUT) {			// ^ʒm
			int rt;
			rt = OpenMap_HelsSend (tinf->exe_sw ,3);
		}
	}
	return	TRUE;
}

int APIENTRY	Disk_Inf_Disp (HWND dwnd)
{
	DWORD	drv;
	int		drvno[26];
	int		i;
	BYTE	msg[1024];
	BYTE	drvnm[12];
	DWORD	drvtyp;
	BYTE	wk[128];
	int		rt;
	ULARGE_INTEGER	dsk1;
	ULARGE_INTEGER	dsk2;
	ULARGE_INTEGER	dsk3;
	BYTE	w[64];
	BYTE	w1[64];


	drv = GetLogicalDrives();

	for (i=0;i<26;i++) {
		drvno[i] = 0;
		if(drv & 1) {
			drvno[i] = 1;
		}
		drv=drv >> 1;
	}
	msg[0] = 0;
	for (i=0;i<26;i++) {
		if (drvno[i]) {
			drvnm[0] = 'A' + (BYTE) i;
			drvnm[1] = ':';
			drvnm[2] = '\\';
			drvnm[3] = 0;
			lstrcat (msg,drvnm);
			lstrcat (msg," ");
			drvtyp =  GetDriveType(drvnm);
			drvtypmsg (drvtyp,wk);
			lstrcat (msg,wk);
			if (drvtyp == DRIVE_FIXED) {
				rt =  GetDiskFreeSpaceEx(drvnm,&dsk1,&dsk2,&dsk3);
				memset (w,0,sizeof(w));
				//_i64toa  (dsk2.QuadPart ,w,10);
				wsprintf(w, "%0d", dsk2.QuadPart);
				CanmaSet (w,w1);
				wsprintf (wk,"   Total Size %s Byte\xd\xa",w1);
				lstrcat (msg,wk);
				memset (w,0,sizeof(w));
				//_i64toa  (dsk3.QuadPart,w,10);
				wsprintf(w, "%0d", dsk3.QuadPart);
				CanmaSet (w,w1);
				wsprintf (wk,"   Free Size %s Byte\xd\xa",w1);
				lstrcat (msg,wk);
			}
		}

	}
	SetWindowText (dwnd,msg);
	return 0;

}

static	void	drvtypmsg (DWORD drvtyp,PBYTE pwk)
{
	lstrcpy (pwk," : ");
	switch (drvtyp) {
	case 0:
		lstrcat (pwk,"s");
		break;
	case 1:
		lstrcat (pwk,"Drive Does Not Exits");
		break;
	case DRIVE_REMOVABLE:
		lstrcat (pwk,"REMOVABLE Drive");
		break;
	case DRIVE_FIXED:
		lstrcat (pwk,"FIXED Drive");
		break;
	case DRIVE_REMOTE:
		lstrcat (pwk,"REMOTE Drive");
		break;
	case DRIVE_CDROM:
		lstrcat (pwk,"CDROM Drive");
		break;
	case DRIVE_RAMDISK:
		lstrcat (pwk,"RAMDISK Drive");
		break;
	}
	lstrcat (pwk,"\xd\xa");

}

static	void CanmaSet (PBYTE ibf,PBYTE obf)
{
	int		ln;
	int		i;
	int		j;
	int		k;
	int		l;
	BYTE	w1[64];
	ln = strlen (ibf);
	
	j=0;
	k=0;
	l=ln;
	for (i=0;i<ln;i++) {
		l--;
		w1[j++] = ibf[l];
		k++;
		if (k== 3) {
			k=0;
			w1[j++] = ',';
		}
	}
	k=j;
	obf[0] = ' ';
	for (i=0;i<j;i++) {
		k--;
		obf[i+1] =w1[k];
	}
	obf[i+1] = 0;
}

int  CapDpCtDll_EofChk (void)
{
	if	(StartExecSw)	EndExec_Set();
	if	(mapstsw)		Creat_Mapview_Cls();
	if	(openmapsw)		Mapview_Close(0,0);
	if	(ctlh_start)	CntlHelsEnd();
	if	(dsph_start)	DspHelsEnd();
	return 0;
}


long  APIENTRY  RegEntrySet (PBYTE lpszValue)
{

	int						iret;
	STARTUPINFO				stinf;
	PROCESS_INFORMATION		prcinf;
	BYTE	fnm[1024];

	lstrcpy (fnm,"regsvr32 ");
	lstrcat (fnm,lpszValue);
//	iret = MessageBox (NULL,fnm,"RegEntrySet",MB_OK);
	memset ((void *) &stinf,0,sizeof(stinf));
	stinf.cb = sizeof(prcinf);
	memset ((void *) &prcinf,0,sizeof(prcinf));
	iret = CreateProcess (0,fnm,0,0,FALSE,CREATE_NEW_CONSOLE,0,0,&stinf,&prcinf);
	if (iret == 0) {
		return  0;
	}
	WaitForSingleObject (prcinf.hProcess,2000);

	CloseHandle (prcinf.hThread );
	CloseHandle (prcinf.hProcess);
	return 0;
}

