#include <windows.h>
#include <stdio.h>
#include <vfw.h>

#include "jpgcnv.h"
#include "bitdsp.h"

extern	HDRAWDIB	hdrawdibDc;

static	int		jpeg_write_lib (LPBYTE jpgdir,long libno,LPBYTE ascdate,PBYTE jbf,long jsize);
static	int		creat_jpglib (LPBYTE libfnm,LPSYSTEMTIME tim,PJPEGFILE_HEAD jhed);
static	int		jpglib_datechk (LPSYSTEMTIME tim,PJPEGFILE_HEAD jhed);

static	int		jpglib_startsw=0;
static	CRITICAL_SECTION	JpgCnv_Critical;
static	PBYTE	jpgbf;

//**************************************************************
//***  JpegLib
//**************************************************************
static	long	WINAPI	Disp_JpgProc (HWND ,UINT,WPARAM,LPARAM);
static	void	Jpeg_Disp (HWND hWnd,PBYTE	pt,long size);
static	int		dispjpglib (long typ,LPBYTE jpgdir,LPBYTE jpglib,DWORD frame,HWND OtWnd);

static	CRITICAL_SECTION	JpgDisp_Critical;

		int		JpgDispInit_Sw=0;
static	HWND	jwnd1;
static	HWND	jwnd2;
static	FARPROC	Jproc1;
static	FARPROC	Jproc2;
static	PBYTE	jptr1;
static	PBYTE	jptr2;
static	PBYTE	jptlib;
static	int		jplen1;
static	int		jplen2;
static	int		jptlen;
	


int	JpegLib_Init (void)
{
	if (jpglib_startsw) return 0;
	InitializeCriticalSection(&JpgCnv_Critical);
	jpgbf = (LPVOID) VirtualAlloc(NULL,JPEGFILE_MAXSIZE,
						MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	
	jpglib_startsw=1;
	return	0;
}

int	JpegLib_End (void)
{
	if (!jpglib_startsw) return 0;

	if (jpgbf) VirtualFree( jpgbf,0,MEM_RELEASE );
	DeleteCriticalSection(&JpgCnv_Critical);
	jpglib_startsw=0;
	return  0;
}


int APIENTRY	JpgWrtLib (LPBYTE jpgdir,long libno,LPBYTE ascdate)
{
	int		ret;
	int		jsize;

	if (!jpglib_startsw) return 0;		// Not Lib Open
//****  Bmp => Jpeg Convert

	if (libno < 0 || libno > 5) return 0;
	EnterCriticalSection(&JpgCnv_Critical);
	jsize = Bmp_To_Jpg (libno,jpgbf);			// bmap => Jpg
	ret = jpeg_write_lib (jpgdir,libno,ascdate,jpgbf,jsize);
	LeaveCriticalSection(&JpgCnv_Critical);
	return ret;
}

int APIENTRY	JpgSetLib (LPBYTE jpgdir,long libno,LPBYTE ascdate)
{
	int		ret;
	int		jsize;

	if (!jpglib_startsw) return 0;		// Not Lib Open
//****  Bmp => Jpeg Convert

	if (libno < 0 || libno > 5) return 0;
	EnterCriticalSection(&JpgCnv_Critical);
	jsize = Jpg_To_Cpy (libno,jpgbf);			// jpg => Jpg
	ret = jpeg_write_lib (jpgdir,libno,ascdate,jpgbf,jsize);
	LeaveCriticalSection(&JpgCnv_Critical);
	return ret;
}


static int jpeg_write_lib (LPBYTE jpgdir,long libno,LPBYTE ascdate,PBYTE jbf,long jsize)
{


	JPEGFILE_HEAD		jhed;
	JPEGFILE_DATA		jdat;
	BYTE				libfnm[2048];
	BYTE				savfnm[2048];
	BYTE				wkhzk[128];
	BYTE				wkno[10];
	int					ln;
	int					rtcd;
	HANDLE				fhndl;
	DWORD				get_len;
	DWORD				wrt_len;
//	DWORD				size;
	LPBYTE				jpgbuf;
	DWORD				jpgsize;
	SYSTEMTIME			tim;
	BYTE				wdate[20];


	jpgsize = jsize;
	jpgbuf = jbf;
//**************************

	ln = lstrlen(ascdate);
	if (ln < sizeof(wdate)) {
		memset (wdate,0,sizeof(wdate));
		memcpy (wdate,ascdate,ln);
	}
	else {
		ln = sizeof(wdate);
		memcpy (wdate,ascdate,ln);
		wdate[ln] = 0;
	}
	GetLocalTime (&tim);

	wsprintf ((PBYTE) &wkno,"%01d",libno);
	lstrcpy (libfnm,jpgdir);
	ln	= lstrlen (libfnm);
	if (ln == 0) {
		lstrcat (libfnm,"\\");
	}
	else {
		if (libfnm[ln-1] != '\\') {
			lstrcat (libfnm,"\\");
		}
	}
	lstrcpy (savfnm,libfnm);

	lstrcat (libfnm,JPEGLIBRAYNAME);
	lstrcat  (libfnm,wkno);
	lstrcat  (libfnm,".cap");
	
	fhndl = CreateFile (libfnm,
					GENERIC_READ | GENERIC_WRITE,
					0,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (fhndl == INVALID_HANDLE_VALUE) {
		rtcd = creat_jpglib (libfnm,&tim,&jhed);
		if (!rtcd) {
			return 0;
		}
	}
	else {
		ReadFile (fhndl,&jhed,sizeof(JPEGFILE_HEAD),&get_len,NULL);
		CloseHandle (fhndl);
		rtcd = jpglib_datechk (&tim,&jhed);
		if (!rtcd) {
			// DATE UNMATCH
			// RENAME
			lstrcat (savfnm,JPEGSAVENAME);
			lstrcat  (savfnm,wkno);
			wsprintf (wkhzk,"_%04d%02d%02d_%02d%02d",
						jhed.yyyy,jhed.mm,jhed.dd,jhed.hh,jhed.mn );
			lstrcat  (savfnm,wkhzk);
			lstrcat  (savfnm,".cap");
			rename (libfnm,savfnm);
			rtcd = creat_jpglib (libfnm,&tim,&jhed);
			if (!rtcd) {
				return 0;
			}
		}
	}
	if (jhed.ftyp	!=	'PJ') {
		return 0;
	}



	fhndl = CreateFile (libfnm,
					GENERIC_READ | GENERIC_WRITE,
					0,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (fhndl == INVALID_HANDLE_VALUE) {
		return 0;
	}
	SetFilePointer (fhndl,jhed.filesize,0,FILE_BEGIN);
	jdat.recno		=	jhed.recken + 1;
	jdat.bck_pos	=	jhed.edpos;
	jdat.nxt_pos	=	jhed.filesize + jpgsize + sizeof(JPEGFILE_DATA);
	jdat.size		=	jpgsize;
	memcpy (jdat.ascdate ,wdate,sizeof(jdat.ascdate));
	WriteFile (fhndl,(VOID*) &jdat,sizeof(JPEGFILE_DATA),&wrt_len,NULL);

	WriteFile (fhndl,jpgbuf,jpgsize,&wrt_len,NULL);
	// head data write
	SetFilePointer (fhndl,0,0,FILE_BEGIN);
	jhed.edpos		=	jhed.filesize ;
	jhed.recken		=	jhed.recken + 1;
	jhed.filesize	=	jhed.filesize + jpgsize + sizeof(JPEGFILE_DATA);
	WriteFile (fhndl,&jhed,sizeof(JPEGFILE_HEAD),&wrt_len,NULL);
	CloseHandle (fhndl);
	return 1;
}


static	int		creat_jpglib (LPBYTE libfnm,LPSYSTEMTIME tim,PJPEGFILE_HEAD jhed)
{ 
	HANDLE				fhndl;
	DWORD				wrt_len;

	fhndl = CreateFile (libfnm,
					GENERIC_READ | GENERIC_WRITE,
					0,
					NULL,
					CREATE_ALWAYS,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
		if (fhndl == INVALID_HANDLE_VALUE) {
			return 0;
		}
		jhed->ftyp		=	'PJ';
		jhed->ver		=	1;
		jhed->filesize	=	sizeof (JPEGFILE_HEAD);
		jhed->recken		=	0;
		jhed->stpos		=	sizeof (JPEGFILE_HEAD);
		jhed->edpos		=	sizeof (JPEGFILE_HEAD);
		jhed->yyyy		=	tim->wYear;
		jhed->mm			=	LOBYTE (tim->wMonth);
		jhed->dd			=	LOBYTE(tim->wDay);
		jhed->hh			=	LOBYTE(tim->wHour);
		jhed->mn			=	LOBYTE(tim->wMinute);

		WriteFile (fhndl,(void *)jhed,sizeof(JPEGFILE_HEAD),&wrt_len,NULL);
		CloseHandle (fhndl);
		return 1;
}

static	int  jpglib_datechk (LPSYSTEMTIME tim,PJPEGFILE_HEAD jhed)
{
	if (tim->wYear   !=  jhed->yyyy) { return 0;} 
	if (tim->wMonth  !=  jhed->mm)   { return 0;} 
	if (tim->wDay    !=  jhed->dd)   { return 0;} 
	if (tim->wHour   !=  jhed->hh)   { return 0;} 
	return 1;
}

int APIENTRY	JpgDispInit (HWND hWnd1,HWND hWnd2)
{

	if (JpgDispInit_Sw) return 0;
	InitializeCriticalSection(&JpgDisp_Critical);

	jwnd1	=	hWnd1;
	jwnd2	=	hWnd2;
	jplen1	=	0;
	jplen2	=	0;
	jptlen	=	0;
	jptr1 =VirtualAlloc(NULL,ALLOC_BITMAPSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	jptr2 =VirtualAlloc(NULL,ALLOC_BITMAPSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	jptlib=VirtualAlloc(NULL,ALLOC_BITMAPSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	Jproc1	=	(FARPROC) GetWindowLong (hWnd1,GWL_WNDPROC);
	SetWindowLong (hWnd1,GWL_WNDPROC,(LONG) Disp_JpgProc);
	Jproc2	=	(FARPROC) GetWindowLong (hWnd2,GWL_WNDPROC);
	SetWindowLong (hWnd2,GWL_WNDPROC,(LONG) Disp_JpgProc);
	JpgDispInit_Sw	=	1;
	return 1;
}

int APIENTRY	JpgDispEnd (void)
{

	if (!JpgDispInit_Sw) return 0;
	SetWindowLong (jwnd1,GWL_WNDPROC,(LONG) Jproc1);
	SetWindowLong (jwnd2,GWL_WNDPROC,(LONG) Jproc2);
	if (jptr1) 	VirtualFree( jptr1,0,MEM_RELEASE );
	if (jptr2) 	VirtualFree( jptr2,0,MEM_RELEASE );
	if (jptlib) VirtualFree( jptlib,0,MEM_RELEASE );
	jptr1	=	0;
	jptlib	=	0;
	jplen1	=	0;
	jplen2	=	0;
	jptlen	=	0;
	DeleteCriticalSection(&JpgDisp_Critical);

	JpgDispInit_Sw = 0;
	return 1;
}


int APIENTRY	JpgDispCopy (long typ)
{

	int		fhsiz=sizeof(BITMAPFILEHEADER);

	if (!JpgDispInit_Sw) return 0;
	if (typ == 0) {
		//  1 => 0
		jplen1 = jplen2;
		CopyMemory (jptr1,jptr2,jplen1);
		Jpeg_Disp (jwnd1,jptr1+fhsiz,jplen1);
	} else if (typ == 1) {
		//  0 => 1
		jplen2 = jplen1;
		CopyMemory (jptr2,jptr1,jplen2);
		Jpeg_Disp (jwnd2,jptr2+fhsiz,jplen2);
	} else {
		return 1;
	}
	return 0;
	
}


int APIENTRY	DspLibInf (LPBYTE jpgdir,DWORD prgno,PJPEGLIB_INF inf)
{
	HANDLE				fhndl;
	BYTE				libfnm[1024];
	BYTE				wkno[10];
	BYTE				jpg_fnm[128];
	JPEGFILE_HEAD		jhed;
	DWORD				get_len;
	int					ln;

	wsprintf ((PBYTE) &wkno,"%01d",prgno);
	lstrcpy (libfnm,jpgdir);
	ln	= lstrlen (libfnm);
	if (ln == 0) {
		lstrcat (libfnm,"\\");
	}
	else {
		if (libfnm[ln-1] != '\\') {
			lstrcat (libfnm,"\\");
		}
	}

	lstrcpy (jpg_fnm,JPEGLIBRAYNAME);
	lstrcat  (jpg_fnm,wkno);
	lstrcat  (jpg_fnm,".cap");
	
	lstrcat (libfnm,jpg_fnm);
	fhndl = CreateFile (libfnm,
					GENERIC_READ,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (fhndl == INVALID_HANDLE_VALUE) {
		return	0;
	}
	ReadFile (fhndl,&jhed,sizeof(JPEGFILE_HEAD),&get_len,NULL);
	CloseHandle (fhndl);
	inf->fken  = jhed.recken ;
	ln = lstrlen(jpg_fnm);
	if (ln < sizeof(inf->fnm)) {
		inf->dkn = ln;
		lstrcpy (inf->fnm ,jpg_fnm);
	}
	else {
		inf->dkn = sizeof(inf->fnm);
		memcpy (inf->fnm ,jpg_fnm,sizeof(inf->fnm));
	}
	return 1;
}



int APIENTRY	DspJpgInf (LPBYTE jpgdir,LPBYTE jpgfnm,PJPEGLIB_INF inf)
{
	HANDLE				fhndl;
	BYTE				libfnm[1024];
	JPEGFILE_HEAD		jhed;
	DWORD				get_len;
	int					ln;

	lstrcpy (libfnm,jpgdir);
	ln	= lstrlen (libfnm);
	if (ln == 0) {
		lstrcat (libfnm,"\\");
	}
	else {
		if (libfnm[ln-1] != '\\') {
			lstrcat (libfnm,"\\");
		}
	}
	
	lstrcat (libfnm,jpgfnm);
	fhndl = CreateFile (libfnm,
					GENERIC_READ,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (fhndl == INVALID_HANDLE_VALUE) {
		return	0;
	}
	ReadFile (fhndl,&jhed,sizeof(JPEGFILE_HEAD),&get_len,NULL);
	CloseHandle (fhndl);
	inf->fken  = jhed.recken ;

	ln = lstrlen(jpgfnm);
	if (ln < sizeof(inf->fnm)) {
		inf->dkn = ln;
		lstrcpy (inf->fnm ,jpgfnm);
	}
	else {
		inf->dkn = sizeof(inf->fnm);
		memcpy (inf->fnm ,jpgfnm,sizeof(inf->fnm));
	}
	return 1;
}

int APIENTRY	DspJpgLib (long typ,LPBYTE jpgdir,LPBYTE jpglib,DWORD frame,HWND OtWnd)
{
	int		rt;

	EnterCriticalSection(&JpgDisp_Critical);
	rt = dispjpglib (typ,jpgdir,jpglib,frame,OtWnd);
	LeaveCriticalSection(&JpgDisp_Critical);
	return	rt;
}



static	int dispjpglib (long typ,LPBYTE jpgdir,LPBYTE jpglib,DWORD frame,HWND OtWnd)
{
	HANDLE				fhndl;
	BYTE				libfnm[1024];
	JPEGFILE_HEAD		jhed;
	JPEGFILE_DATA		jdat;
	DWORD				get_len;
	int					ln;
	DWORD				recno;
	DWORD				strec;
	DWORD				edrec;
	DWORD				stpos;
	LPBYTE				bfpt;
	int					*bfln;
	int					size;
	int					bmsize;
	int					bmfsize;
	HWND				dspwnd;
	JPEGDATA_INF		jpginf;
	BYTE				odt[128];

	if (!JpgDispInit_Sw) return 0;

	if			(typ == 0) {
		bfln	=	&jplen1;
		bfpt	=	jptr1;
		dspwnd	=	jwnd1;
	} else if	(typ == 1) {
		bfln	=	&jplen2;
		bfpt	=	jptr2;
		dspwnd	=	jwnd2;
	} else {
		return 0;
	}
	recno = frame;
	lstrcpy (libfnm,jpgdir);
	ln	= lstrlen (libfnm);
	if (ln == 0) {
		lstrcat (libfnm,"\\");
	}
	else {
		if (libfnm[ln-1] != '\\') {
			lstrcat (libfnm,"\\");
		}
	}

	lstrcat (libfnm,jpglib);

	fhndl = CreateFile (libfnm,
					GENERIC_READ,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (fhndl == INVALID_HANDLE_VALUE) {
		return	0;
	}
	ReadFile (fhndl,&jhed,sizeof(JPEGFILE_HEAD),&get_len,NULL);

	edrec = jhed.recken ;
	if (recno > edrec ) {
		CloseHandle (fhndl);
		return 0;
	}
	strec = 1;
	stpos  = jhed.stpos ;
	while (strec < recno) {
		SetFilePointer (fhndl,stpos,0,FILE_BEGIN);
		ReadFile (fhndl,(VOID*) &jdat,sizeof(JPEGFILE_DATA),&get_len,NULL);
		strec = jdat.recno + 1;
		stpos = jdat.nxt_pos ;
	}
	SetFilePointer (fhndl,stpos,0,FILE_BEGIN);
	ReadFile (fhndl,(VOID*) &jdat,sizeof(JPEGFILE_DATA),&get_len,NULL);
	if (jdat.recno != recno) {
		CloseHandle (fhndl);
		return 0;
	}
	size	=	jdat.size ;
	jptlen	=	size;
	jpginf.dsize = sizeof(jdat.ascdate);
	memcpy (jpginf.data,jdat.ascdate ,sizeof(jdat.ascdate));
	ReadFile (fhndl,jptlib,size,&get_len,NULL);
	CloseHandle (fhndl);

	bmfsize = Jpg_Bmp (jptlib,jptlen,bfpt);
	if (bmfsize) {
		bmsize = bmfsize - sizeof(BITMAPFILEHEADER);
		if (bmsize > 0) {
			*bfln = bmsize;
			Jpeg_Disp (dspwnd,bfpt+sizeof(BITMAPFILEHEADER),bmsize);
		}
	}
	memset (odt,0,sizeof(odt));
	memcpy (odt,jpginf.data,jpginf.dsize);
	if (OtWnd)	SetWindowText (OtWnd,odt);
	return 1;

}

static	void Jpeg_Disp (HWND hWnd,PBYTE	pt,long size)
{
	HDC			hDc;
//	PAINTSTRUCT ps;
	RECT		wrect;
	BITMAPINFOHEADER	vfmt;

	if (!hWnd) return;
	if (!size) return;
	GetClientRect (hWnd,&wrect);
	hDc		=	GetDC (hWnd);
	memcpy ((void*) &vfmt,pt,sizeof(BITMAPINFOHEADER));
	DrawDibDraw (hdrawdibDc,
				hDc,
				wrect.left,
				wrect.top,
				wrect.right  - wrect.left,
				wrect.bottom - wrect.top,
				(LPBITMAPINFOHEADER) &vfmt,
				pt+sizeof(BITMAPINFOHEADER),
				0,0,-1,-1,0);
	ReleaseDC(hWnd,hDc);
}

static	long WINAPI   Disp_JpgProc (HWND		hWnd,
									   UINT		iMessage,
									   WPARAM	wParam,
									   LPARAM	lParam)

{

	HDC			hDc;
//	PAINTSTRUCT ps;
	RECT		wrect;
	BITMAPINFOHEADER	vfmt;
	PBYTE		pt;
	FARPROC		Old_Proc;
	int			jplen;


	if        (jwnd1 == hWnd) {
		pt = jptr1+sizeof(BITMAPFILEHEADER);
		Old_Proc = Jproc1;
		if (!jplen1) return DefWindowProc (hWnd,iMessage,wParam,lParam) ;
		jplen	=	jplen1;
	} else if (jwnd2 == hWnd) {
		pt = jptr2+sizeof(BITMAPFILEHEADER);
		Old_Proc = Jproc2;
		if (!jplen2) return DefWindowProc (hWnd,iMessage,wParam,lParam) ;
		jplen	=	jplen2;
	} else {
		return DefWindowProc (hWnd,iMessage,wParam,lParam) ;
	}
	switch (iMessage)  {
		case	WM_USER+2223:
			GetClientRect (hWnd,&wrect);
			hDc		=	GetDC (hWnd);
			memcpy ((void*) &vfmt,pt,sizeof(BITMAPINFOHEADER));
			DrawDibDraw (hdrawdibDc,
					hDc,
					wrect.left,
					wrect.top,
					wrect.right  - wrect.left,
					wrect.bottom - wrect.top,
					(LPBITMAPINFOHEADER) &vfmt,
					pt+sizeof(BITMAPINFOHEADER),
					0,0,-1,-1,0);
			ReleaseDC(hWnd,hDc);
			return 		FALSE;
		case WM_PAINT:
			PostMessage (hWnd,WM_USER+2223,0,0);	// Triger
			break;
	}
	return  CallWindowProc ((WNDPROC) Old_Proc,hWnd,iMessage,wParam,lParam);

}


//**********************************
//*  Cap Lib 
//**********************************

int APIENTRY	CaplibCreat (LPBYTE capfnm)
{ 
	SYSTEMTIME		tim;
	JPEGFILE_HEAD		jhed;
	HANDLE				fhndl;
	DWORD				wrt_len;

	fhndl = CreateFile (capfnm,
					GENERIC_READ | GENERIC_WRITE,
					0,
					NULL,
					CREATE_NEW,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (fhndl == INVALID_HANDLE_VALUE) {
		return 1;
	}
	GetLocalTime (&tim);
	memset (&jhed,0,sizeof(jhed));
	jhed.ftyp		=	'PJ';
	jhed.ver		=	1;
	jhed.filesize	=	sizeof (JPEGFILE_HEAD);
	jhed.recken		=	0;
	jhed.stpos		=	sizeof (JPEGFILE_HEAD);
	jhed.edpos		=	sizeof (JPEGFILE_HEAD);
	jhed.yyyy		=	tim.wYear;
	jhed.mm			=	LOBYTE (tim.wMonth);
	jhed.dd			=	LOBYTE(tim.wDay);
	jhed.hh			=	LOBYTE(tim.wHour);
	jhed.mn			=	LOBYTE(tim.wMinute);

	WriteFile (fhndl,(void *)&jhed,sizeof(JPEGFILE_HEAD),&wrt_len,NULL);
	CloseHandle (fhndl);
	return 0;
}
int APIENTRY	CapLibAdd (LPBYTE libdir,LPBYTE ifnm,LPBYTE capdir,LPBYTE ofnm)
{

	HANDLE				ihndl;
	HANDLE				ohndl;
	BYTE				libfnm[1024];
	BYTE				outfnm[1024];
	JPEGFILE_HEAD		inhed;
	JPEGFILE_HEAD		othed;
	JPEGFILE_DATA		jdat;
	JPEGFILE_DATA		odat;
	DWORD				get_len;
	DWORD				wrt_len;
	long				jpgsize;
	int					ln;
	PBYTE				jpgbfpt=0;
	DWORD				edrec;
	DWORD				strec;
	DWORD				stpos;

	lstrcpy (libfnm,libdir);
	ln	= lstrlen (libfnm);
	if (ln == 0) {
		lstrcat (libfnm,"\\");
	}
	else {
		if (libfnm[ln-1] != '\\') {
			lstrcat (libfnm,"\\");
		}
	}

	lstrcat (libfnm,ifnm);

	lstrcpy (outfnm,capdir);
	ln	= lstrlen (outfnm);
	if (ln == 0) {
		lstrcat (outfnm,"\\");
	}
	else {
		if (outfnm[ln-1] != '\\') {
			lstrcat (outfnm,"\\");
		}
	}
	lstrcat (outfnm,ofnm);

	jpgbfpt=VirtualAlloc(NULL,JPEGFILE_MAXSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);


	ihndl = CreateFile (libfnm,
					GENERIC_READ,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ihndl == INVALID_HANDLE_VALUE) {
		if (jpgbfpt) VirtualFree( jpgbfpt,0,MEM_RELEASE );
		return	1;
	}
	ReadFile (ihndl,&inhed,sizeof(JPEGFILE_HEAD),&get_len,NULL);
	if (get_len != sizeof(JPEGFILE_HEAD)) {
		CloseHandle (ihndl);
		if (jpgbfpt) VirtualFree( jpgbfpt,0,MEM_RELEASE );
		return	2;
	}

	ohndl = CreateFile (outfnm,
					GENERIC_READ | GENERIC_WRITE,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ohndl == INVALID_HANDLE_VALUE) {
		CloseHandle (ihndl);
		if (jpgbfpt) VirtualFree( jpgbfpt,0,MEM_RELEASE );
		return	3;
	}
	
	ReadFile (ohndl,&othed,sizeof(JPEGFILE_HEAD),&get_len,NULL);
	if (get_len != sizeof(JPEGFILE_HEAD)) {
		CloseHandle (ihndl);
		CloseHandle (ohndl);
		if (jpgbfpt) VirtualFree( jpgbfpt,0,MEM_RELEASE );
		return	4;
	}


	edrec = inhed.recken ;
	strec = 0;
	stpos  = inhed.stpos ;
	while (strec < edrec) {
		ReadFile (ihndl,(VOID*) &jdat,sizeof(JPEGFILE_DATA),&get_len,NULL);
		if (get_len != sizeof(JPEGFILE_DATA)) {
			break;
		}
		jpgsize	=	jdat.size ;
		ReadFile (ihndl,jpgbfpt,jpgsize,&get_len,NULL);
		if ((int)get_len != jpgsize) {
			break;
		}
		SetFilePointer (ohndl,othed.filesize,0,FILE_BEGIN);
		odat.recno		=	othed.recken + 1;
		odat.bck_pos	=	othed.edpos;
		odat.nxt_pos	=	othed.filesize + jpgsize + sizeof(JPEGFILE_DATA);
		odat.size		=	jpgsize;
		memcpy (odat.ascdate ,jdat.ascdate,sizeof(jdat.ascdate));
		WriteFile (ohndl,(VOID*) &odat,sizeof(JPEGFILE_DATA),&wrt_len,NULL);

		WriteFile (ohndl,jpgbfpt,jpgsize,&wrt_len,NULL);
		othed.edpos		=	othed.filesize ;
		othed.recken	=	othed.recken + 1;
		othed.filesize	=	othed.filesize + jpgsize + sizeof(JPEGFILE_DATA);
		strec++;
	}

	SetFilePointer (ohndl,0,0,FILE_BEGIN);
	WriteFile (ohndl,&othed,sizeof(JPEGFILE_HEAD),&wrt_len,NULL);

	CloseHandle (ohndl);
	CloseHandle (ihndl);
	if (jpgbfpt) VirtualFree( jpgbfpt,0,MEM_RELEASE );

	return	0;
}


