#include <windows.h>
#include <stdio.h>
#include <mmsystem.h>
#include <vfw.h>

#include "jpgcnv.h"

#define		AVI_ALLOC_BITMAPSIZE	(640*480*3+1000)

extern	HDRAWDIB	hdrawdibDc;

static	int	AviFileWrt (int no,PBYTE bf,int bmsize);
static int bitfmtcmp (void *pfmt1,void *pfmt2);
static int GetBmpData (HWND hwnd,int width,int high,
					   LPBITMAPINFOHEADER pvfmt,PBYTE pt,LPBYTE buf,DWORD dsw,PBYTE dtxt);
static void dspbar (HWND dwnd,int ncnt,int mcnt);

int		CapAvi_StartSW=0;
static	PBYTE		bmpbfpt;
static	PBYTE		jpgbfpt;
static	PAVIFILE	pavifile=0;
static	PAVISTREAM	pavistream=0;
static	PAVISTREAM	ppavistream=0;
static	PAVISTREAM	pavicompress=0;
static	AVISTREAMINFO		avisinfo;
static	AVICOMPRESSOPTIONS	avicmpopt;
static	LPAVICOMPRESSOPTIONS	pavicmpopt;
static	HBRUSH dsp_hbrsh;

int  APIENTRY CapAviInit (void)
{
	if (CapAvi_StartSW) return 1;

	bmpbfpt =VirtualAlloc(NULL,AVI_ALLOC_BITMAPSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	if (!bmpbfpt) {
		return 2;
	}
	jpgbfpt =VirtualAlloc(NULL,AVI_ALLOC_BITMAPSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	if (!jpgbfpt) {
		if (bmpbfpt) 	VirtualFree( bmpbfpt,0,MEM_RELEASE );
		return 3;
	}
	AVIFileInit();

	//dsp_hbrsh = CreateSolidBrush(RGB(255,255,0));
	dsp_hbrsh = CreateSolidBrush(RGB(0,0,255));
	CapAvi_StartSW = 1;
	return 0;
}

int  APIENTRY CapAviEnd (void)
{

	if (!CapAvi_StartSW) return 1;
	
	if (bmpbfpt) 	VirtualFree( bmpbfpt,0,MEM_RELEASE );
	if (jpgbfpt) 	VirtualFree( bmpbfpt,0,MEM_RELEASE );
	bmpbfpt = 0;

	AVIFileExit(); 
	DeleteObject(dsp_hbrsh);
	CapAvi_StartSW = 0;
	return 0;
}

//int  APIENTRY CapToAviConv (HWND hwnd,PBYTE capfnm,PBYTE avifnm)
int  APIENTRY CapToAviConv (HWND hwnd,PBYTE capfnm,PBYTE avifnm,
							HWND scwnd,DWORD bfmtyp,DWORD frame,DWORD daysw)
{

	HANDLE				fhndl;
	JPEGFILE_HEAD		jhed;
	JPEGFILE_DATA		jdat;
	DWORD				get_len;
	DWORD				strec;
	DWORD				edrec;
	DWORD				stpos;
	int					size;
	int					bmsize;
	int					bmfsize;
	JPEGDATA_INF		jpginf;
	int					ret;
	int					rtcode;
	HRESULT				avirt;
	BITMAPINFOHEADER	bfmt;
	PBYTE				wbf;
	int					maxct;
	int					nowct;
	BYTE				hzk[64];

	if (!CapAvi_StartSW) return 1;

	
	memset (&bfmt,0,sizeof(bfmt));
	bfmt.biSize = sizeof(bfmt);
	if (bfmtyp == 2) {
		bfmt.biWidth = 160;
		bfmt.biHeight = 120;
	} else if (bfmtyp == 1) {
		bfmt.biWidth = 320;
		bfmt.biHeight = 240;
	} else {
		bfmt.biWidth = 640;
		bfmt.biHeight = 480;
	}
	bfmt.biCompression = BI_RGB;
	bfmt.biPlanes = 1;
	bfmt.biBitCount = 24;

	avirt= AVIFileOpen(&pavifile,avifnm,OF_CREATE|OF_WRITE,NULL);
	if(!pavifile) return 1;
  

	memset (&avisinfo,0,sizeof(avisinfo));
	avisinfo.fccType	=	streamtypeVIDEO;
//	avisinfo.fccHandler =	 mmioFOURCC ('M','S','V','C');
	avisinfo.fccHandler =	 0;
	avisinfo.dwScale	=	1;
	if (frame > 10) {
		avisinfo.dwRate		=	10;
	} else {
		avisinfo.dwRate		=	frame;
	}
	lstrcpy (avisinfo.szName,"capeditvb CopyRight 2005 By onpc ");
	avirt = AVIFileCreateStream(pavifile,&pavistream, &avisinfo);
	if (avirt != AVIERR_OK) {
		AVIFileRelease(pavifile);
		pavifile=0;
		return 1;
	}

	memset (&avicmpopt,0,sizeof(avicmpopt));
	avicmpopt.dwFlags = AVICOMPRESSF_VALID ;
	avicmpopt.fccType = streamtypeVIDEO;
	avicmpopt.fccHandler = mmioFOURCC ('M','S','V','C');
	avicmpopt.dwQuality = 6500;
	avicmpopt.dwKeyFrameEvery  = 7;
	ppavistream = pavistream;
	pavicmpopt = &avicmpopt;
//	avirt = AVISaveOptions (hwnd,ICMF_CHOOSE_KEYFRAME |ICMF_CHOOSE_DATARATE  | ICMF_CHOOSE_PREVIEW,                        
//			1,  &ppavistream,  &pavicmpopt);


	avirt = AVIMakeCompressedStream(&pavicompress,pavistream,&avicmpopt,NULL);
	if (avirt != AVIERR_OK) {
		AVIFileRelease(pavifile);
		pavifile=0;
		return 1;
	}


	avirt = AVIStreamSetFormat(pavicompress,0,&bfmt,sizeof(bfmt));        
	if (avirt != AVIERR_OK) {
		AVIFileRelease(pavifile);
		pavifile=0;
		return 1;
	}

	fhndl = CreateFile (capfnm,
					GENERIC_READ,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (fhndl == INVALID_HANDLE_VALUE) {
		return	2;
	}
	ReadFile (fhndl,&jhed,sizeof(JPEGFILE_HEAD),&get_len,NULL);
	if (get_len != sizeof(JPEGFILE_HEAD)) {
		CloseHandle (fhndl);
		return 1;
	}

	edrec = jhed.recken ;
	strec = 0;
	stpos  = jhed.stpos ;
	rtcode = 0;
	maxct = jhed.recken;
	while (strec < edrec) {
		ret = ReadFile (fhndl,(VOID*) &jdat,sizeof(JPEGFILE_DATA),&get_len,NULL);
		if (get_len != sizeof(JPEGFILE_DATA)) {
			rtcode = 1;
			break;
		}
		nowct = strec + 1;
		dspbar  (scwnd,nowct,maxct);
		size	=	jdat.size ;
		memset (hzk,0x20,sizeof(hzk));
		memcpy (hzk+2,jdat.ascdate,sizeof(jdat.ascdate));
		hzk[23] = 0;
		jpginf.dsize = sizeof(jdat.ascdate);
		memcpy (jpginf.data,jdat.ascdate ,sizeof(jdat.ascdate));
		ReadFile (fhndl,jpgbfpt,size,&get_len,NULL);
		if ((int)get_len != size) {
			rtcode = 1;
			break;
		}

		bmfsize = Jpg_Bmp (jpgbfpt,size,bmpbfpt);
		if (bmfsize) {
			bmsize = bmfsize - sizeof(BITMAPFILEHEADER);
			if (bmsize > 0) {
				//**  bitmap format chk
				wbf = (PBYTE) bmpbfpt+sizeof(BITMAPFILEHEADER);
				ret = bitfmtcmp ((void *) wbf,(void *) &bfmt);
				if (ret || daysw) {
					bmsize = GetBmpData (hwnd,bfmt.biWidth,bfmt.biHeight,(LPBITMAPINFOHEADER)wbf,(PBYTE) wbf,(PBYTE) wbf,daysw,hzk);
				}
				ret = AviFileWrt (strec,bmpbfpt+sizeof(BITMAPFILEHEADER),bmsize);
				if (ret) {
					rtcode =1;
					break;
				}
			}
		}
		strec++;
	}
	CloseHandle (fhndl);
	if (pavistream) {
		avirt =  AVIStreamRelease(pavistream);
		pavistream=		0;
	}
	if (pavicompress) {
		avirt =  AVIStreamRelease(pavicompress);
		pavicompress	=	0;
	}
 

	AVIFileRelease(pavifile);
	pavifile=0;
	return rtcode;
}

static	int	AviFileWrt (int no,PBYTE bf,int bmsize)
{
	BITMAPINFOHEADER	bmpfmt;
	int					bmpsize;
	PBYTE				pbmp;
	HRESULT				avirt;

	memcpy (&bmpfmt,bf,sizeof(BITMAPINFOHEADER));
	bmpsize	=		bmsize - sizeof(BITMAPINFOHEADER);
	pbmp	=	bf + sizeof(BITMAPINFOHEADER);
	avirt	=	AVIStreamWrite(pavicompress,no,1,pbmp,bmpsize,AVIIF_KEYFRAME ,NULL,NULL);
 	if (avirt != AVIERR_OK) {
		return 1;
	}

	return 0;
}



static int GetBmpData (HWND hwnd,int width,int high,
					   LPBITMAPINFOHEADER pvfmt,PBYTE pt,LPBYTE buf,
					   DWORD dsw,PBYTE dtxt)
{

	int					rtcd;
	DWORD				size;
//*****   work
	DWORD				ln;
	int					ncol;
    int                 sz;

//************ ͗p
	HDC					in_hDC;
	BITMAP				in_bm;
	HBITMAP				in_hbmp;

//************ p
	RECT				wrect;
	HDC					mem_hDC;
	HBITMAP				mem_hbmp;


//***********  bitmap aria
    LPBYTE				to_hbit;
	LPBITMAPINFOHEADER	to_bithed;
	LPRGBQUAD			to_bitcol;


	in_hDC		=	GetDC (hwnd);
//	GetClientRect	  (hwnd,&rect);
	wrect.right  = width ;
	wrect.bottom = high ;
	wrect.left = 0;
	wrect.top  = 0;
	in_hbmp		=	CreateCompatibleBitmap (in_hDC,wrect.right,wrect.bottom);
	GetObject  (in_hbmp,sizeof(BITMAP),(LPSTR)&in_bm);

	mem_hDC		=	CreateCompatibleDC(in_hDC);
	SetMapMode (mem_hDC,GetMapMode (in_hDC));

	mem_hbmp =  (HBITMAP) SelectObject  (mem_hDC,in_hbmp);

	DrawDibDraw (hdrawdibDc,
				mem_hDC,
				wrect.left,
				wrect.top,
				wrect.right  - wrect.left,
				wrect.bottom - wrect.top,
				(LPBITMAPINFOHEADER) pvfmt,
				pt+sizeof(BITMAPINFOHEADER),
				0,0,-1,-1,0);

	if (dsw == 1) {				//  
		DrawText (mem_hDC,dtxt,lstrlen(dtxt),&wrect,DT_TOP | DT_LEFT);
	} else 	if (dsw == 2) {		//  
		DrawText (mem_hDC,dtxt,lstrlen(dtxt),&wrect,DT_SINGLELINE |DT_BOTTOM  | DT_LEFT);
	} else 	if (dsw == 3) {		//  E
		DrawText (mem_hDC,dtxt,lstrlen(dtxt),&wrect,DT_TOP | DT_RIGHT);
	} else 	if (dsw == 4) {		//  E
		DrawText (mem_hDC,dtxt,lstrlen(dtxt),&wrect,DT_SINGLELINE | DT_BOTTOM | DT_RIGHT);
	}
	SelectObject  (mem_hDC,mem_hbmp);
	ncol = in_bm.bmPlanes * in_bm.bmBitsPixel;

	if  (ncol <= 1) {
		ncol = 1;
		sz  = 1;
    }
	else if (ncol <= 4 ) {
		ncol = 4;
		sz  = 16;
	}
	else if (ncol <= 8 ) {
		ncol = 8;
		sz  = 256;
	}
	else {
		ncol = 24;
		sz  = 1024;
	}

	memset (buf,0,sizeof(BITMAPINFOHEADER));
	to_bithed	=	(LPBITMAPINFOHEADER) buf;
	to_bitcol	=	(LPRGBQUAD) buf + sizeof(BITMAPINFOHEADER);
	if (ncol == 24) {
		ln	=	0;
		to_hbit		= (LPBYTE)	buf + sizeof(BITMAPINFOHEADER);
	}
	else {
		ln 		=	(sz * sizeof(RGBQUAD));
		(LPBYTE)to_hbit		= (LPBYTE)buf + sizeof(BITMAPINFOHEADER) + (sz * sizeof(RGBQUAD));
	}

	to_bithed->biSize	=	sizeof(BITMAPINFOHEADER);

	to_bithed->biWidth	=	in_bm.bmWidth;
	to_bithed->biHeight	=	in_bm.bmHeight;

//	to_bithed->biPlanes	=	in_bm.bmPlanes;
	to_bithed->biPlanes	=	1;
//	to_bithed->biBitCount=	in_bm.bmBitsPixel;
	to_bithed->biBitCount=	ncol;
	to_bithed->biCompression =	BI_RGB;


  	rtcd = GetDIBits ( mem_hDC,in_hbmp,0,in_bm.bmHeight,
				to_hbit,
				(LPBITMAPINFO) to_bithed,
				DIB_RGB_COLORS);

	DeleteObject (in_hbmp);
	DeleteObject (mem_hbmp);
	DeleteDC	 (mem_hDC);
	ReleaseDC    (hwnd,in_hDC);
	size = to_bithed->biSizeImage + ln;
	return size;

}

static int bitfmtcmp (void *pfmt1,void *pfmt2)
{
	LPBITMAPINFOHEADER	pfm1;
	LPBITMAPINFOHEADER	pfm2;

	pfm1 = (LPBITMAPINFOHEADER) pfmt1;
	pfm2 = (LPBITMAPINFOHEADER) pfmt2;
	if (pfm1->biWidth == pfm2->biWidth && pfm1->biHeight == pfm2->biHeight ) {
		return 0;
	}
	return 1;
}

static void dspbar (HWND dwnd,int ncnt,int mcnt)
{
	HDC		hDc;
	RECT	wrct;
	double  x1;

	x1 = (double) ncnt / (double) mcnt;
	GetClientRect	  (dwnd,&wrct);
	wrct.right = (long) ( (double) wrct.right * x1);

	hDc = GetDC (dwnd);
	FillRect(hDc,&wrct,(HBRUSH) dsp_hbrsh);
	ReleaseDC    (dwnd,hDc);
}