#include <windows.h>
#include <stdio.h>
#include <vfw.h>

#include "jpgcnv.h"
#include "bmpcnv.h"
#include "bitdsp.h"

#define		CAPEDITHEAD_MAXREC		(3600*24+1000)
typedef struct {
	DWORD		ken;
	JPEGFILE_DATA	hed[100];
} CAPEDITHEAD,*PCAPEDITHEAD;


typedef struct {
	DWORD		recno;
	DWORD		jpgsize;
	WORD		yy;
	WORD		mm;
	WORD		dd;
	WORD		h;
	WORD		m;
	WORD		d;
} CAPEDITRECINF,*PCAPEDITRECINF;


extern	HDRAWDIB	hdrawdibDc;

	int		CapEdit_StartSW=0;

static	PBYTE			jpgwpt;
static	PBYTE			bmpwpt;
static	JPEGFILE_HEAD	jpghd;
static	PCAPEDITHEAD	capptbl;
static	BYTE			tmpdir[1024];
static	BYTE			tmpfnm[1024];
static	int				capmln=0;
int APIENTRY	CapEditOpen (LPBYTE libdir,LPBYTE fnm)
{
	HANDLE				ihndl;
	HANDLE				ohndl;
	BYTE				libfnm[1024];
	JPEGFILE_DATA		jdat;
	DWORD				get_len;
	DWORD				wrt_len;
	long				jpgsize;
	int					ln;
	PBYTE				jpgbfpt=0;
	DWORD				edrec;
	DWORD				strec;
	DWORD				stpos;
	int					rtcd;

	if (CapEdit_StartSW) return 1;

	CapEdit_StartSW=1;

	jpgwpt=VirtualAlloc(NULL,JPEGFILE_MAXSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	if (!jpgwpt) {
		return 1;
	}
	bmpwpt  = VirtualAlloc(NULL,ALLOC_BITMAPSIZE,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	if (!bmpwpt) {
		return 1;
	}
	capmln = sizeof(JPEGFILE_DATA)*CAPEDITHEAD_MAXREC+100;
	capptbl =(PCAPEDITHEAD) VirtualAlloc(NULL,capmln,MEM_RESERVE | MEM_COMMIT,PAGE_READWRITE);
	if (!capptbl) {
		return 1;
	}

	GetTempPath(sizeof(tmpdir),tmpdir);
	ln = strlen(tmpdir);
	if (!ln) {
		lstrcpy(tmpdir,"\\");
	} else	if (tmpdir[ln-1] != '\\') {
		lstrcat (tmpdir,"\\");
	}
	lstrcpy (tmpfnm,tmpdir);
	lstrcat (tmpfnm,fnm);

	lstrcpy (libfnm,libdir);
	ln = lstrlen(libfnm);
	if (!ln) {
		lstrcpy(libfnm,"\\");
	} else	if (libfnm[ln-1] != '\\') {
		lstrcat (libfnm,"\\");
	}
	lstrcat (libfnm,fnm);


	ihndl = CreateFile (libfnm,
					GENERIC_READ,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ihndl == INVALID_HANDLE_VALUE) {
		return	2;
	}
	ReadFile (ihndl,&jpghd,sizeof(JPEGFILE_HEAD),&get_len,NULL);
	if (get_len != sizeof(JPEGFILE_HEAD)) {
		CloseHandle (ihndl);
		return	3;
	}

	ohndl = CreateFile (tmpfnm,
					GENERIC_READ | GENERIC_WRITE,
					FILE_SHARE_WRITE,
					NULL,
					CREATE_ALWAYS,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ohndl == INVALID_HANDLE_VALUE) {
		CloseHandle (ihndl);
		return	4;
	}




	WriteFile (ohndl,&jpghd,sizeof(JPEGFILE_HEAD),&get_len,NULL);
	if (get_len != sizeof(JPEGFILE_HEAD)) {
		CloseHandle (ihndl);
		CloseHandle (ohndl);
		return	5;
	}
	capptbl->ken = jpghd.recken ;

	edrec = jpghd.recken ;
	strec = 0;
	stpos  = jpghd.stpos ;
	rtcd	=	0;
	while (strec < edrec) {
		ReadFile (ihndl,(VOID*) &jdat,sizeof(JPEGFILE_DATA),&get_len,NULL);
		if (get_len != sizeof(JPEGFILE_DATA)) {
			rtcd	=	1;
			break;
		}
		jpgsize	=	jdat.size ;
		capptbl->hed[strec].recno = jdat.recno ;
		capptbl->hed[strec].bck_pos = jdat.bck_pos ;
		capptbl->hed[strec].nxt_pos  = jdat.nxt_pos  ;
		capptbl->hed[strec].size  = jdat.size  ;
		memcpy (capptbl->hed[strec].ascdate,jdat.ascdate,sizeof(jdat.ascdate));

		ReadFile (ihndl,jpgwpt,jpgsize,&get_len,NULL);
		if ((int)get_len != jpgsize) {
			rtcd	=	1;
			break;
		}
		WriteFile (ohndl,(VOID*) &jdat,sizeof(JPEGFILE_DATA),&wrt_len,NULL);
		if ((int)wrt_len != sizeof(JPEGFILE_DATA)) {
			rtcd	=	1;
			break;
		}

		WriteFile (ohndl,jpgwpt,jpgsize,&wrt_len,NULL);
		if ((int)wrt_len != jpgsize) {
			rtcd	=	1;
			break;
		}
		strec++;
	}

	CloseHandle (ohndl);
	CloseHandle (ihndl);

	return	rtcd;



}



int APIENTRY	CapEditClose (void)
{

	if (!jpgwpt) VirtualFree( jpgwpt,0,MEM_RELEASE );
	jpgwpt=0;
	if (!bmpwpt) VirtualFree( bmpwpt,0,MEM_RELEASE );
	bmpwpt=0;
	if (!capptbl) VirtualFree( capptbl,0,MEM_RELEASE );
	capptbl=0;
	CapEdit_StartSW=0;
	return 0;
}


int APIENTRY	CapEditBmpDsp (DWORD recno,HWND dspwnd)
{
	DWORD				k;
	DWORD				kn;
	int					hit;
	DWORD				getrec;
	HANDLE				ihndl;
	HANDLE				ohndl;
	DWORD				getpos;
	JPEGFILE_DATA		jdat;
	DWORD				get_len;
	DWORD				jpgsize;
	BYTE				wfnm[1024];

	if(!CapEdit_StartSW) return 1;

	if (!recno) return 2;
	kn = capptbl->ken;
	if (!kn) return 2;

	hit = 0;
	getpos = jpghd.stpos;
	for (k=0;k<kn;k++) {
		if (capptbl->hed [k].recno == recno ) {
			getrec = k;
			hit = 1;
			break;
		}
		getpos = capptbl->hed[k].nxt_pos ;
	}
	if (!hit) {
		return 3;
	}
	ihndl = CreateFile (tmpfnm,
					GENERIC_READ,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ihndl == INVALID_HANDLE_VALUE) {
		return	4;
	}
	SetFilePointer (ihndl,getpos,0,FILE_BEGIN);

	ReadFile (ihndl,(VOID*) &jdat,sizeof(JPEGFILE_DATA),&get_len,NULL);
	if (get_len != sizeof(JPEGFILE_DATA)) {
		CloseHandle (ihndl);
		return	5;
	}
	jpgsize = jdat.size;

	ReadFile (ihndl,jpgwpt,jpgsize,&get_len,NULL);
	if ((int)get_len != jpgsize) {
		CloseHandle (ihndl);
		return	6;
	}
	CloseHandle (ihndl);

	lstrcpy (wfnm,tmpdir);
	lstrcat (wfnm,"CapEditBmpDsp.jpg");
	if (dspwnd) SetWindowText (dspwnd,wfnm);
	ohndl = CreateFile (wfnm,
					GENERIC_READ | GENERIC_WRITE,
					FILE_SHARE_WRITE,
					NULL,
					CREATE_ALWAYS,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ohndl == INVALID_HANDLE_VALUE) {
		CloseHandle (ihndl);
		return	4;
	}

	WriteFile (ohndl,jpgwpt,jpgsize,&get_len,NULL);
	if ((int)get_len != jpgsize) {
		CloseHandle (ohndl);
		return	5;
	}
	CloseHandle (ohndl);
	return 0;
}


int APIENTRY	CapEditGetInf ()
{

	if(!CapEdit_StartSW) return 0;
	return (int) capptbl->ken ;
}

int APIENTRY	CapEditGetRecInf (DWORD recno,PCAPEDITRECINF pcrinf)
{
	int		no;
	BYTE	wk[30];

	if(!CapEdit_StartSW) return 1;
	if (!recno) return 2;
	no = recno -1;
	pcrinf->recno  = capptbl->hed[no].recno;
	pcrinf->jpgsize = capptbl->hed[no].size;
	memcpy (wk,capptbl->hed[no].ascdate,20);
//  01234567890123456789
//  2005/12/12 10:10:10
	wk[4] = 0;
	wk[7] = 0;
	wk[10] = 0;
	wk[13] = 0;
	wk[16] = 0;
	wk[19] = 0;
	pcrinf->yy = atoi (wk+0);
	pcrinf->mm = atoi (wk+5);
	pcrinf->dd = atoi (wk+8);
	pcrinf->h  = atoi (wk+11);
	pcrinf->m  = atoi (wk+14);
	pcrinf->d  = atoi (wk+17);
	return 0;
}


int APIENTRY	CapEditSetDateInf (DWORD recno,PBYTE hzk)
{
	int		idx;
	BYTE	whzk[30];
	int		ln;

	if (!CapEdit_StartSW) return 1;

	if (recno < 1) return 1;
	idx= recno - 1;
	ln = strlen(hzk);
	if (ln > 20) ln = 20;
	memset (whzk,0x20,20);
	memcpy(whzk,hzk,ln);
	if (idx < (int) capptbl->ken) {
			memcpy (capptbl->hed[idx].ascdate ,whzk,20);
	} else {
		return 1;
	}
	return 0;
}

int APIENTRY	CapEditSetJpgRec (DWORD recno,PBYTE bfnm)
{
	int		idx;

	long	jpgsize;
	long	size;
	BITMAPFILEHEADER	bhead;
	HANDLE				ihndl;
	HANDLE				ohndl;
	DWORD				get_len;
	DWORD				wrt_len;
	int					fhdlen=sizeof(BITMAPFILEHEADER);
	JPEGFILE_DATA		jdat;
	DWORD				getpos;
	int					rtcd;

	if (!CapEdit_StartSW) return 1;

	if (recno < 1) return 1;
	idx= recno - 1;
	if (idx < (int) capptbl->ken) {
	} else {
		return 1;
	}

	ihndl = CreateFile (bfnm,
					GENERIC_READ,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ihndl == INVALID_HANDLE_VALUE) {
		return	4;
	}
	ReadFile (ihndl,(void *)&bhead,sizeof(bhead),&get_len,NULL);
	if (get_len != sizeof(bhead)) {
		CloseHandle (ihndl);
		return 4;
	}
	if (bhead.bfType != 'MB') {
		CloseHandle (ihndl);
		return 4;
	}
	size = bhead.bfSize - fhdlen;
	memcpy (bmpwpt,(void*) &bhead,fhdlen);
	ReadFile (ihndl,bmpwpt+fhdlen,size,&get_len,NULL);
	if ((int) get_len != size) {
		CloseHandle (ihndl);
		return 4;
	}
	CloseHandle (ihndl);
	jpgsize = Bmp_Jpg (20,(PBYTE) bmpwpt,bhead.bfSize,jpgwpt);
	ohndl = CreateFile (tmpfnm,
					GENERIC_READ | GENERIC_WRITE,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ohndl == INVALID_HANDLE_VALUE) {
		CloseHandle (ihndl);
		return	4;
	}
	getpos = jpghd.filesize;	// EOF
	if (idx == 0) {
		//  fast rec
		jpghd.stpos = getpos;
	} else {
		// not fast
		capptbl->hed[idx-1].nxt_pos = getpos;
	}
	capptbl->hed[idx].size  = jpgsize;
	jdat = capptbl->hed[idx];

	SetFilePointer (ihndl,getpos,0,FILE_BEGIN);
	rtcd = 0;
	WriteFile (ohndl,(VOID*) &jdat,sizeof(JPEGFILE_DATA),&wrt_len,NULL);
	if ((int)wrt_len != sizeof(JPEGFILE_DATA)) {
		rtcd	=	1;
	}

	WriteFile (ohndl,jpgwpt,jpgsize,&wrt_len,NULL);
	if ((int)wrt_len != jpgsize) {
		rtcd	=	1;
	}
	CloseHandle (ohndl);
	jpghd.filesize  = jpghd.filesize  + sizeof(JPEGFILE_DATA) + jpgsize;

	return rtcd;
}


int APIENTRY	CapEditNewJpgRec (PBYTE bfnm)
{



	long	jpgsize;
	long	size;
	BITMAPFILEHEADER	bhead;
	HANDLE				ihndl;
	HANDLE				ohndl;
	DWORD				get_len;
	DWORD				wrt_len;
	int					fhdlen=sizeof(BITMAPFILEHEADER);
	JPEGFILE_DATA		jdat;
	DWORD				getpos;
	int					rtcd;
	JPEGFILE_HEAD		jhead;

	ihndl = CreateFile (bfnm,
					GENERIC_READ,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ihndl == INVALID_HANDLE_VALUE) {
		return	4;
	}
	ReadFile (ihndl,(void *)&bhead,sizeof(bhead),&get_len,NULL);
	if (get_len != sizeof(bhead)) {
		CloseHandle (ihndl);
		return 4;
	}
	if (bhead.bfType != 'MB') {
		CloseHandle (ihndl);
		return 4;
	}
	size = bhead.bfSize - fhdlen;
	memcpy (bmpwpt,(void*) &bhead,fhdlen);
	ReadFile (ihndl,bmpwpt+fhdlen,size,&get_len,NULL);
	if ((int) get_len != size) {
		CloseHandle (ihndl);
		return 4;
	}
	CloseHandle (ihndl);
	jpgsize = Bmp_Jpg (20,(PBYTE) bmpwpt,bhead.bfSize,jpgwpt);

	jhead = jpghd;

	jhead.stpos		= sizeof(JPEGFILE_HEAD);
	jhead.edpos		= sizeof(JPEGFILE_HEAD);
	jhead.recken =	1;
	capptbl->ken = 1;
	capptbl->hed [0].bck_pos	= sizeof(JPEGFILE_HEAD);
	capptbl->hed [0].nxt_pos	= jpgsize + sizeof(JPEGFILE_HEAD) + sizeof(JPEGFILE_DATA);
	capptbl->hed [0].recno		= 1;
	capptbl->hed [0].size		= jpgsize;
	memset (capptbl->hed [0].ascdate,' ',20);

	ohndl = CreateFile (tmpfnm,
					GENERIC_READ | GENERIC_WRITE,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ohndl == INVALID_HANDLE_VALUE) {
		CloseHandle (ihndl);
		return	4;
	}

	getpos	=	jhead.stpos;
	jdat	=	capptbl->hed [0];
	SetFilePointer (ohndl,getpos,0,FILE_BEGIN);
	rtcd = 0;
	WriteFile (ohndl,(VOID*) &jdat,sizeof(JPEGFILE_DATA),&wrt_len,NULL);
	if ((int)wrt_len != sizeof(JPEGFILE_DATA)) {
		rtcd	=	1;
	}

	WriteFile (ohndl,jpgwpt,jpgsize,&wrt_len,NULL);
	if ((int)wrt_len != jpgsize) {
		rtcd	=	1;
	}
	CloseHandle (ohndl);
	jhead.edpos = jdat.nxt_pos ;
	jhead.filesize	= capptbl->hed [0].nxt_pos;
	jpghd = jhead;
	return rtcd;
}

int APIENTRY	CapEditAddJpgRec (DWORD recno,PBYTE bfnm,DWORD flg)
{
	int		idx;

	int		i;
	int		k;
	long	jpgsize;
	long	size;
	BITMAPFILEHEADER	bhead;
	HANDLE				ihndl;
	HANDLE				ohndl;
	DWORD				get_len;
	DWORD				wrt_len;
	int					fhdlen=sizeof(BITMAPFILEHEADER);
	JPEGFILE_DATA		jdat;
	DWORD				getpos;
	int					rtcd;

	if (!CapEdit_StartSW) return 1;

	if( flg == 3) {
		return	CapEditNewJpgRec (bfnm);
	}
	if (recno < 1) return 1;
	idx= recno - 1;
	if (idx < (int) capptbl->ken) {
	} else {
		return 1;
	}

	ihndl = CreateFile (bfnm,
					GENERIC_READ,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ihndl == INVALID_HANDLE_VALUE) {
		return	4;
	}
	ReadFile (ihndl,(void *)&bhead,sizeof(bhead),&get_len,NULL);
	if (get_len != sizeof(bhead)) {
		CloseHandle (ihndl);
		return 4;
	}
	if (bhead.bfType != 'MB') {
		CloseHandle (ihndl);
		return 4;
	}
	size = bhead.bfSize - fhdlen;
	memcpy (bmpwpt,(void*) &bhead,fhdlen);
	ReadFile (ihndl,bmpwpt+fhdlen,size,&get_len,NULL);
	if ((int) get_len != size) {
		CloseHandle (ihndl);
		return 4;
	}
	CloseHandle (ihndl);
	jpgsize = Bmp_Jpg (20,(PBYTE) bmpwpt,bhead.bfSize,jpgwpt);
	ohndl = CreateFile (tmpfnm,
					GENERIC_READ | GENERIC_WRITE,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ohndl == INVALID_HANDLE_VALUE) {
		CloseHandle (ihndl);
		return	4;
	}
	getpos = jpghd.filesize;	// EOF
	if (flg == 0) {		// Oɒǉ
		k = jpghd.recken;
		for (i=idx;i<(int)capptbl->ken;i++) {
			capptbl->hed[k] = capptbl->hed[k-1];
			k--;
		}
		capptbl->ken ++;
		if (idx == 0) {
			//  fast rec
			capptbl->hed[idx].nxt_pos	=	jpghd.stpos;
			jpghd.stpos		=	getpos;
		} else {
			// not fast
			capptbl->hed[idx].nxt_pos	=	capptbl->hed[idx-1].nxt_pos;
			capptbl->hed[idx-1].nxt_pos = getpos;
		}
		capptbl->hed [idx].bck_pos	=	0;
		capptbl->hed [idx].recno	=	0;
		capptbl->hed [idx].size		=	jpgsize;
		memset (capptbl->hed [idx].ascdate,' ',20);
		jdat		=	capptbl->hed [idx];
	} else {
		//		ɒǉ
		k = jpghd.recken;
		idx++;
		for (i=idx;i<(int)capptbl->ken;i++) {
			capptbl->hed[k] = capptbl->hed[k-1];
			k--;
		}
		capptbl->ken ++;
		capptbl->hed[idx].nxt_pos	=	capptbl->hed[idx-1].nxt_pos;
		capptbl->hed[idx-1].nxt_pos = getpos;
		capptbl->hed [idx].bck_pos	=	0;
		capptbl->hed [idx].recno	=	0;
		capptbl->hed [idx].size		=	jpgsize;
		memset (capptbl->hed [idx].ascdate,' ',20);

		jdat			=	capptbl->hed [idx];
		jdat.size		=	jpgsize;
		jdat.bck_pos	=	capptbl->hed[idx].bck_pos ;
		jdat.nxt_pos	=	capptbl->hed[idx].nxt_pos ;
		jdat.recno		=	0;
		memset (jdat.ascdate,' ',20);
		capptbl->hed[idx].nxt_pos = getpos;
	}
	k = 1;
	for (i=0;i<(int)capptbl->ken;i++) {
		capptbl->hed[i].recno = k;
		k++;
	}
	jdat.recno	=	capptbl->hed[idx].recno;

	SetFilePointer (ohndl,getpos,0,FILE_BEGIN);
	rtcd = 0;
	WriteFile (ohndl,(VOID*) &jdat,sizeof(JPEGFILE_DATA),&wrt_len,NULL);
	if ((int)wrt_len != sizeof(JPEGFILE_DATA)) {
		rtcd	=	1;
	}

	WriteFile (ohndl,jpgwpt,jpgsize,&wrt_len,NULL);
	if ((int)wrt_len != jpgsize) {
		rtcd	=	1;
	}
	CloseHandle (ohndl);
	jpghd.filesize  = jpghd.filesize  + sizeof(JPEGFILE_DATA) + jpgsize;
	jpghd.recken++;
	return rtcd;
}


int APIENTRY	CapEditDelJpgRec (DWORD recno)
{
	int		idx;
	int		i;
	int		k;
	JPEGFILE_DATA		jdat;


	if (!CapEdit_StartSW) return 1;

	if (recno < 1) return 1;
	idx= recno - 1;
	if (idx < (int) capptbl->ken) {
	} else {
		return 1;
	}

	jdat = capptbl->hed[idx];
	if (idx == 0) {
		jpghd.stpos = jdat.nxt_pos ;
	} else {
		capptbl->hed[idx-1].nxt_pos = jdat.nxt_pos ;
	}
	if (capptbl->ken  == 1) {
		capptbl->ken = 0;
		jpghd.stpos = sizeof(JPEGFILE_HEAD);
		jpghd.edpos = sizeof(JPEGFILE_HEAD);
	} else {
		k = capptbl->ken -1;
		for (i= idx;i<k ;i++) {
			capptbl->hed[i] = capptbl->hed[i+1];
		}
		capptbl->ken--;
		for (i=0;i<(int)capptbl->ken;i++) {
			capptbl->hed[i].recno = i + 1;
		}
		i = capptbl->ken - 1;
		jpghd.edpos = capptbl->hed[i].nxt_pos - capptbl->hed[i].size - sizeof(JPEGFILE_DATA);
	}
	jpghd.recken = capptbl->ken;
	return 0;
}

int APIENTRY	CapEditSave (LPBYTE libdir,LPBYTE fnm)
{

	HANDLE				ihndl;
	HANDLE				ohndl;
	BYTE				libfnm[1024];
	JPEGFILE_DATA		jdat;
	JPEGFILE_HEAD		jhd;
	JPEGFILE_HEAD		whead;
	int					i;
	DWORD				get_len;
	DWORD				wrt_len;
	long				jpgsize;
	int					ln;
	DWORD				getpos;
	DWORD				bckpos;
	DWORD				nexpos;
	int					rtcd;

	if (!CapEdit_StartSW) return 1;


	lstrcpy (libfnm,libdir);
	ln = strlen(libfnm);
	if (!ln) {
		lstrcpy(libfnm,"\\");
	} else	if (libfnm[ln-1] != '\\') {
		lstrcat (libfnm,"\\");
	}
	lstrcat (libfnm,fnm);


	ihndl = CreateFile (tmpfnm,
					GENERIC_READ,
					FILE_SHARE_WRITE,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ihndl == INVALID_HANDLE_VALUE) {
		return	2;
	}
	ReadFile (ihndl,&jhd,sizeof(JPEGFILE_HEAD),&get_len,NULL);
	if (get_len != sizeof(JPEGFILE_HEAD)) {
		CloseHandle (ihndl);
		return	3;
	}

	ohndl = CreateFile (libfnm,
					GENERIC_READ | GENERIC_WRITE,
					FILE_SHARE_WRITE,
					NULL,
					CREATE_ALWAYS,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);
	if (ohndl == INVALID_HANDLE_VALUE) {
		CloseHandle (ihndl);
		return	4;
	}

	jhd	  = jpghd;
	whead = jpghd;
	whead.stpos		=	sizeof(JPEGFILE_HEAD);
	whead.edpos		=	sizeof(JPEGFILE_HEAD);
	whead.filesize	=	sizeof(JPEGFILE_HEAD);
	whead.recken		=	0;
	WriteFile (ohndl,&whead,sizeof(JPEGFILE_HEAD),&wrt_len,NULL);
	if (wrt_len != sizeof(JPEGFILE_HEAD)) {
		CloseHandle (ihndl);
		CloseHandle (ohndl);
		return	5;
	}
	rtcd = 0;
	bckpos = 0;
	nexpos = 0;
	getpos = jhd.stpos ;
	for (i=0;i<(int)capptbl->ken;i++) {
		SetFilePointer (ihndl,getpos,0,FILE_BEGIN);
		getpos = capptbl->hed [i].nxt_pos;
		ReadFile (ihndl,&jdat,sizeof(JPEGFILE_DATA),&get_len,NULL);
		if (get_len != sizeof(JPEGFILE_DATA)) {
			rtcd = 1;
			break;
		}
		jpgsize = jdat.size ;
		ReadFile (ihndl,jpgwpt,jpgsize,&get_len,NULL);
		if ((int)get_len != jpgsize) {
			rtcd = 1;
			break;
		}
		whead.filesize = whead.filesize + sizeof(JPEGFILE_DATA) + jpgsize;
		whead.recken++;
		whead.edpos = whead.filesize ;
		if (i == 0) {
			jdat.bck_pos	=	sizeof(JPEGFILE_HEAD);
			bckpos = jdat.bck_pos;
		} else {
			jdat.bck_pos	=	bckpos;
			bckpos			=	jdat.nxt_pos;
		}
		jdat.nxt_pos	=	whead.edpos;
		jdat.recno		=	i + 1;
		jdat.size		=	jpgsize;
		memcpy (jdat.ascdate ,capptbl->hed[i].ascdate,sizeof(jdat.ascdate));

		WriteFile (ohndl,(VOID*) &jdat,sizeof(JPEGFILE_DATA),&wrt_len,NULL);
		if ((int)wrt_len != sizeof(JPEGFILE_DATA)) {
			rtcd	=	1;
			break;
		}
		WriteFile (ohndl,jpgwpt,jpgsize,&wrt_len,NULL);
		if ((int)wrt_len != jpgsize) {
			rtcd	=	1;
			break;
		}
	}
	CloseHandle (ihndl);

	SetFilePointer (ohndl,0,0,FILE_BEGIN);
	rtcd = 0;
	WriteFile (ohndl,(VOID*) &whead,sizeof(JPEGFILE_HEAD),&wrt_len,NULL);
	if ((int)wrt_len != sizeof(JPEGFILE_HEAD)) {
		rtcd	=	1;
	}

//	SetFilePointer (ohndl,whead.filesize ,0,FILE_BEGIN);
	CloseHandle (ohndl);
	return 0;
}

int APIENTRY	CapBitDateDisp (HDC mem_hDC,DWORD width,DWORD high,DWORD dsw,PBYTE dtxt)
{
	RECT	wrect;

	wrect.left		= 0;
	wrect.right		= width;
	wrect.top		= 0;
	wrect.bottom	= high;

	if (dsw == 1) {				//  
		DrawText (mem_hDC,dtxt,lstrlen(dtxt),&wrect,DT_TOP | DT_LEFT);
	} else 	if (dsw == 2) {		//  
		DrawText (mem_hDC,dtxt,lstrlen(dtxt),&wrect,DT_SINGLELINE |DT_BOTTOM  | DT_LEFT);
	} else 	if (dsw == 3) {		//  E
		DrawText (mem_hDC,dtxt,lstrlen(dtxt),&wrect,DT_TOP | DT_RIGHT);
	} else 	if (dsw == 4) {		//  E
		DrawText (mem_hDC,dtxt,lstrlen(dtxt),&wrect,DT_SINGLELINE | DT_BOTTOM | DT_RIGHT);
	}

	return 0;
}
