#include <windows.h>
#include <vfw.h>
#include <math.h>
#include <commctrl.h>  
#include "bmpcnv.h"

#define USE_BITMAXSIZE	(640*480*4+100000)		// 921,600 Byte + 100,000(\j
#define USE_JPGMAXSIZE	(640*480*4+100000)		// BMP WL & JPG BUFF


typedef struct {
	long   tm1;
	long   tm2;
	long   tm3;
	long   tm4;
	long   tm5;
} TIMESTSINF,*PTIMESTSINF;

typedef struct {
	BYTE	b;
	BYTE	g;
	BYTE	r;
	BYTE	dmy;
} RGB32BITTBL,*PRGB32BITTBL;

typedef struct {
	BYTE	b;
	BYTE	g;
	BYTE	r;
} RGB24BITTBL,*PRGB24BITTBL;

typedef struct {
	WORD	rgb;
}  RGB16BITTBL,*PRGB16BITTBL;


HDRAWDIB	hdrawdibCvb;
PBYTE		pcvbbmp;
PBYTE		pcvbjpg;


static  void	Conv16To24 (PRGB24BITTBL intbl,PRGB24BITTBL ottbl);
static	int GetBmpFile(PBYTE,PBYTE,PBYTE);
static	int	Get_bmtfile (HWND hwnd,LPBITMAPINFOHEADER pvfmt,PBYTE pt,LPBYTE buf);
//static  int Get_bmtfile_cnvt (HWND hwnd,LPBITMAPINFOHEADER pvfmt,PBYTE pt,LPBYTE buf,int cnvflg);
static	void bitmap_conv (LPBITMAPINFOHEADER,PBYTE,PBYTE,int);
static	void Video_Disp (HWND hWnd,PBYTE buf);
static  int BmpFileSend (PBYTE	ofnm,PBYTE pbf,int bfsize);
static int	bitscalecnv (PBYTE ibf,PBYTE obf,int scl);








static	INITCOMMONCONTROLSEX	initcom;
static	int	CapVbDll_Exe=0;

int APIENTRY CapVbDll_Start()
{
	if (CapVbDll_Exe) return 1;
	CapVbDll_Exe = 1;
	BmpCnvDll_Strat();		// ***** BMPCNV.DLL STRAT
	initcom.dwSize = sizeof(INITCOMMONCONTROLSEX);
	initcom.dwICC = ICC_INTERNET_CLASSES | ICC_TAB_CLASSES;
	InitCommonControlsEx(&initcom);
	hdrawdibCvb = DrawDibOpen();
	pcvbbmp = VirtualAlloc(NULL, USE_BITMAXSIZE, MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
	pcvbjpg = VirtualAlloc(NULL, USE_JPGMAXSIZE, MEM_RESERVE | MEM_COMMIT, PAGE_READWRITE);
	return 0;
}

int APIENTRY CapVbDll_End()
{
	if (!CapVbDll_Exe) return 1;
	CapVbDll_Exe = 0;
	VirtualFree(pcvbbmp, 0, MEM_RELEASE);
	VirtualFree(pcvbjpg, 0, MEM_RELEASE);
	DrawDibClose(hdrawdibCvb);
	BmpCnvDll_End();
	return 0;
}



int APIENTRY GetDirName(PBYTE inidir,PBYTE ifnm,PBYTE filter,HWND twnd)
{
	int		rt;
	int		i;

	BYTE			fnm[2048];
	BYTE			flt[2048];
	BYTE			idir[2048];
	static	OPENFILENAME	ofh;


	fnm[0] = 0;
	flt[0] = 0;
	idir[0] = 0;
	if (*ifnm)	lstrcpy (fnm,ifnm);
	if (*inidir) lstrcpy (idir,inidir);
	i = 0;
	while (filter[i]){
		if (filter[i] < 0x20)	flt[i] = 0;
		else					flt[i] = filter[i];
		i++;
		flt[i] = 0;
	}
	memset (&ofh,0,sizeof(ofh));
	ofh.lStructSize = sizeof(ofh);
	ofh.hwndOwner = twnd;
	ofh.lpstrFilter = flt;
	ofh.nFilterIndex = 1;
	ofh.lpstrCustomFilter = 0;
	ofh.nMaxCustFilter    = 0;
	ofh.lpstrFile  = fnm;
	ofh.nMaxFile  = sizeof (fnm);
	ofh.lpstrInitialDir = idir;
	ofh.Flags =  OFN_PATHMUSTEXIST |  OFN_NOCHANGEDIR;
	rt = GetOpenFileName ( &ofh);
	if (rt == FALSE) return 1;
	SetWindowText (twnd,fnm);
	return	0;
}



int APIENTRY GetTempPathName(HWND hwnd)
{
	int		rt;
	BYTE			tmpath[1024];
	BYTE			tmpfnm[2048];

	rt = GetTempPath( 1024,tmpath);
	if (rt > 0) {
		rt = GetTempFileName (tmpath,"CAP",0,tmpfnm);
		if (rt > 0) {
			SetWindowText (hwnd,tmpfnm);
			return 0;
		}
	}
	SetWindowText (hwnd,"CAPVBWK");
	return 1;
}


int APIENTRY BmptoJpgConvert (HWND cnvwnd,PBYTE ibmpf,PBYTE ojpgf,int qualty,PTIMESTSINF pstsinf)
{
	BITMAPINFOHEADER	bfmt;
	int		sz;
	int		bsize;
	int		jsize;
	int		bmfsize;
	LPBITMAPFILEHEADER		pbmfhdr;
//	HANDLE	fhndl;
//	int		wrtsz;

	pstsinf->tm1 = 0;		// BMP CONVERT TIME
	pstsinf->tm2 = 0;		// BMP ANGLE   TIME
	pstsinf->tm3 = 0;		// BMO SCAL    TIME
	pstsinf->tm4 = 0;		// BMP DISPLAY TIME
	pstsinf->tm5 = 0;		// Not Use

	sz = GetBmpFile (ibmpf,(PBYTE) &bfmt,(PBYTE) pcvbbmp);
	if (sz == 0) return 0;		//* FILE ERROR
	if (bfmt.biCompression == BI_RGB) {
		bmfsize = sz + sizeof (BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	} else if (	bfmt.biCompression == '024I' ||
				bfmt.biCompression == 'VUYI'	) {
		//******  RGB CONVERT
		pstsinf->tm1 = timeGetTime();
		bsize = Get_bmtfile (cnvwnd,(LPBITMAPINFOHEADER)&bfmt,
								pcvbbmp+sizeof(BITMAPFILEHEADER),pcvbjpg+sizeof(BITMAPFILEHEADER));
		pstsinf->tm1 = timeGetTime() - pstsinf->tm1;
		if (!bsize) return	0; //* BITMAP CONVERT ERROR
		pbmfhdr =(LPBITMAPFILEHEADER) pcvbjpg;
		pbmfhdr->bfType	= 'MB';
		pbmfhdr->bfOffBits =  sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
		pbmfhdr->bfSize    =  pbmfhdr->bfOffBits + bsize;
		bmfsize = pbmfhdr->bfSize ;
		CopyMemory (pcvbbmp,pcvbjpg,bmfsize);
	} else {
		return 0; 		//* BITMAP FORMAT ERROR
	}
	pstsinf->tm5 = timeGetTime();
	jsize = Bmp_Jpg (qualty,(PBYTE) pcvbbmp,bmfsize,pcvbjpg);
	pstsinf->tm5 = timeGetTime() - pstsinf->tm5;
	//*  JPEG FILE WRITE
	jsize = BmpFileSend (ojpgf,pcvbjpg,jsize);
	return jsize;
}


int APIENTRY BmpEdit (HWND dspwnd,HWND cnvwnd,PBYTE ibmpf,PBYTE ojpgf,
						   int cnvflg,int scale,PTIMESTSINF pstsinf)
{
	BITMAPINFOHEADER	bfmt;
	BITMAPINFOHEADER	cfmt;
	int		sz;
	int		bsize;
//	int		jsize;
	int		bmfsize;
//	int		fsndsz;

	LPBITMAPFILEHEADER		pbmfhdr;
//	HANDLE	fhndl;
//	int		wrtsz;
	int		bhdsize=sizeof(BITMAPFILEHEADER);
	int		bifsize=sizeof(BITMAPINFOHEADER);

	pstsinf->tm1 = 0;		// BMP CONVERT TIME
	pstsinf->tm2 = 0;		// BMP ANGLE   TIME
	pstsinf->tm3 = 0;		// BMO SCAL    TIME
	pstsinf->tm4 = 0;		// BMP DISPLAY TIME
	pstsinf->tm5 = 0;		// Not Use
	
	sz = GetBmpFile (ibmpf,(PBYTE) &bfmt,(PBYTE) pcvbbmp);
	if (sz == 0) return 0;		//* FILE ERROR
	if (bfmt.biCompression != BI_RGB) {
		//******  RGB CONVERT MODE
		pstsinf->tm1 = timeGetTime();
		bsize =  Get_bmtfile (cnvwnd,(LPBITMAPINFOHEADER)&bfmt,
							pcvbbmp+bhdsize,
							pcvbjpg+bhdsize);
		pstsinf->tm1 = timeGetTime() - pstsinf->tm1;
		if (!bsize) return	0; //* BITMAP CONVERT ERROR
		CopyMemory ((PBYTE) &cfmt,pcvbjpg+bhdsize,bifsize);
	} else {
	// RGB FORMAT MODE
		CopyMemory ((PBYTE) &cfmt,pcvbbmp+bhdsize,bifsize);
		CopyMemory (pcvbjpg+bhdsize,pcvbbmp+bhdsize,sz);
	}
	pstsinf->tm2 = timeGetTime();
	bitmap_conv ((LPBITMAPINFOHEADER)&cfmt,
							pcvbjpg+bhdsize+bifsize,
							pcvbbmp+bhdsize+bifsize,
							scale);
	pstsinf->tm2 = timeGetTime() - pstsinf->tm2;

	CopyMemory (pcvbbmp+bhdsize,pcvbjpg+bhdsize,bifsize);
	//******  RGB CONVERT
	pstsinf->tm3 = timeGetTime();

	bsize = bitscalecnv (pcvbbmp+bhdsize,pcvbjpg+bhdsize,cnvflg);

	pstsinf->tm3 = timeGetTime() - pstsinf->tm3;
	if (!bsize) return	0; //* BITMAP CONVERT ERROR
	pstsinf->tm4 = timeGetTime();
	Video_Disp (dspwnd,pcvbjpg+bhdsize);
	pstsinf->tm4 = timeGetTime() - pstsinf->tm4;

	CopyMemory ((PBYTE) &cfmt,pcvbjpg+bhdsize,bifsize);
	
	pbmfhdr =(LPBITMAPFILEHEADER) pcvbjpg;
	pbmfhdr->bfType	= 'MB';
	pbmfhdr->bfOffBits =  sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
	pbmfhdr->bfSize    =  pbmfhdr->bfOffBits + bsize;
	bmfsize = pbmfhdr->bfSize ;
//		CopyMemory (pcvbbmp,pcvbjpg,bmfsize);
	//*  BMP FILE WRITE
	bmfsize = BmpFileSend (ojpgf,pcvbjpg,bmfsize);
	return bmfsize;
}



int APIENTRY BmptoJpgEdit (HWND dspwnd,HWND cnvwnd,PBYTE ibmpf,PBYTE ojpgf,
						   int qualty,int cnvflg,int scale,PTIMESTSINF pstsinf)
{
	BITMAPINFOHEADER	bfmt;
	BITMAPINFOHEADER	cfmt;
	int		sz;
	int		bsize;
	int		jsize;
	int		bmfsize;
	LPBITMAPFILEHEADER		pbmfhdr;
//	HANDLE	fhndl;
//	int		wrtsz;
	int		bhdsize=sizeof(BITMAPFILEHEADER);
	int		bifsize=sizeof(BITMAPINFOHEADER);
	
	pstsinf->tm1 = 0;		// BMP CONVERT TIME
	pstsinf->tm2 = 0;		// BMP ANGLE   TIME
	pstsinf->tm3 = 0;		// BMO SCAL    TIME
	pstsinf->tm4 = 0;		// BMP DISPLAY TIME
	pstsinf->tm5 = 0;		// Not Use
	
	sz = GetBmpFile (ibmpf,(PBYTE) &bfmt,(PBYTE) pcvbbmp);
	if (sz == 0) return 0;		//* FILE ERROR
	if (bfmt.biCompression != BI_RGB) {
		//******  RGB CONVERT
		pstsinf->tm1 = timeGetTime();
		bsize = Get_bmtfile (cnvwnd,(LPBITMAPINFOHEADER)&bfmt,
								pcvbbmp+bhdsize,
								pcvbjpg+bhdsize);
		pstsinf->tm1 = timeGetTime() - pstsinf->tm1;
		if (!bsize) return	0; //* BITMAP CONVERT ERROR
		CopyMemory ((PBYTE) &cfmt,pcvbjpg+bhdsize,bifsize);
	} else {
		CopyMemory ((PBYTE) &cfmt,pcvbbmp+bhdsize,bifsize);
		CopyMemory (pcvbjpg+bhdsize,pcvbbmp+bhdsize,sz);
	}
	pstsinf->tm2 = timeGetTime();
	bitmap_conv ((LPBITMAPINFOHEADER)&cfmt,
							pcvbjpg+bhdsize+bifsize,
							pcvbbmp+bhdsize+bifsize,
							scale);
	pstsinf->tm2 = timeGetTime() - pstsinf->tm2;

	CopyMemory (pcvbbmp+bhdsize,pcvbjpg+bhdsize,bifsize);
	if (cfmt.biCompression == BI_RGB ) {
		//******  RGB CONVERT
		pstsinf->tm3 = timeGetTime();
		bsize = bitscalecnv (pcvbbmp+bhdsize,pcvbjpg+bhdsize,cnvflg);

//		bsize = Get_bmtfile_cnvt (cnvwnd,(LPBITMAPINFOHEADER)&cfmt,
//								pcvbbmp+bhdsize,
//								pcvbjpg+bhdsize,
//								cnvflg);

		pstsinf->tm3 = timeGetTime() - pstsinf->tm3;
		if (!bsize) return	0; //* BITMAP CONVERT ERROR
		CopyMemory ((PBYTE) &cfmt,pcvbjpg+bhdsize,bifsize);
	
		pbmfhdr =(LPBITMAPFILEHEADER) pcvbjpg;
		pbmfhdr->bfType	= 'MB';
		pbmfhdr->bfOffBits =  sizeof(BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);
		pbmfhdr->bfSize    =  pbmfhdr->bfOffBits + bsize;
		bmfsize = pbmfhdr->bfSize ;
		pstsinf->tm4 = timeGetTime();
		Video_Disp (dspwnd,pcvbjpg+bhdsize);
		pstsinf->tm4 = timeGetTime() - pstsinf->tm4;
//		CopyMemory (pcvbbmp,pcvbjpg,bmfsize);
	} else {
		return 0; 		//* BITMAP FORMAT ERROR
	}

	pstsinf->tm5 = timeGetTime();
	jsize = Bmp_Jpg (qualty,pcvbjpg ,bmfsize,pcvbbmp);
	pstsinf->tm5 = timeGetTime() - pstsinf->tm5;
	//*  JPEG FILE WRITE
	jsize = BmpFileSend (ojpgf,pcvbbmp,jsize);
	return jsize;
}

static  int BmpFileSend (PBYTE	ofnm,PBYTE pbf,int bfsize)
{

	HANDLE		fhndl;
	DWORD		wrtsz;

	//*  BMP FILE WRITE
	fhndl = CreateFile (ofnm,
					GENERIC_WRITE,
					0,
					NULL,
					CREATE_ALWAYS,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);

	if (fhndl != INVALID_HANDLE_VALUE) {
		WriteFile (fhndl,pbf,bfsize,&wrtsz,0);
		CloseHandle (fhndl);
		return	(int) wrtsz;
	}
	return 0;
}

static	int GetBmpFile(PBYTE bfnm,PBYTE  bmp,PBYTE pbmbf) 
{

	LPBITMAPFILEHEADER		pbmfhdr;
	LPBITMAPINFOHEADER		pbmaphdr;
	HANDLE	fhndl;
	BOOL	rt;
	DWORD	getsz;
	DWORD	bisize;
	PBYTE	fbmpptr;

	pbmfhdr		= (LPBITMAPFILEHEADER) pbmbf;
	pbmaphdr	= (LPBITMAPINFOHEADER) (pbmbf + sizeof(BITMAPFILEHEADER));
	fbmpptr		= pbmbf + sizeof (BITMAPFILEHEADER) + sizeof(BITMAPINFOHEADER);

	fhndl = CreateFile (bfnm,
					GENERIC_READ,
					0,
					NULL,
					OPEN_EXISTING,
					FILE_ATTRIBUTE_NORMAL,		// 
					NULL);

	if (fhndl == INVALID_HANDLE_VALUE) {
		return 0;
	}
	rt = ReadFile (fhndl,pbmfhdr,sizeof(BITMAPFILEHEADER),&getsz,0);
	if (pbmfhdr->bfType == 'MB' ) {
		rt = ReadFile (fhndl,pbmaphdr,sizeof(BITMAPINFOHEADER),&getsz,0);
		if (rt) {
			CopyMemory (bmp,(PBYTE) pbmaphdr,sizeof(BITMAPINFOHEADER));
			bisize = pbmfhdr->bfSize - sizeof(BITMAPFILEHEADER) - sizeof(BITMAPINFOHEADER);
			rt = ReadFile (fhndl,(PBYTE)fbmpptr,bisize,&getsz,0); 
			CloseHandle (fhndl);
			return bisize;
		}
	}
	CloseHandle (fhndl);
	return 0;
}


static void Video_Disp (HWND hWnd,PBYTE	buf)
{
	HDC			hDC;
	RECT		wrect;
	BITMAPINFOHEADER	vfmt;

		memcpy ((void*) &vfmt,buf,sizeof(BITMAPINFOHEADER));

		GetClientRect (hWnd,&wrect);
		hDC = GetDC (hWnd);
		DrawDibDraw (hdrawdibCvb,
					hDC,
					wrect.left,
					wrect.top,
					wrect.right  - wrect.left,
					wrect.bottom - wrect.top,
					(LPBITMAPINFOHEADER) &vfmt,
					buf+sizeof(BITMAPINFOHEADER),
					0,0,-1,-1,0);

		ReleaseDC (hWnd,hDC);

}

static int	bitscalecnv (PBYTE ibf,PBYTE obf,int scl)
{
	LPBITMAPINFOHEADER	pbfmt;
	int		size;
	int		iysize,ixsize;
	int		ixst,ixed;
	int		iyst,iyed;
	int		iypt,ixpt;
	int		cysize,cxsize;
	int		i,j;
	int		xpos,ypos;
	double  yl,xl;
	struct rgbtbl {
		BYTE  b;
		BYTE  g;
		BYTE  r;
	} ;
	struct rgbtbl	*pirgb;
	struct rgbtbl	*porgb;
	PBYTE	pt;
	PBYTE	ipt = ibf+sizeof(BITMAPINFOHEADER);

	pirgb = (struct rgbtbl	*) (ibf+sizeof(BITMAPINFOHEADER));
	porgb = (struct rgbtbl	*) (obf+sizeof(BITMAPINFOHEADER));

	pbfmt =(LPBITMAPINFOHEADER) ibf;
	size = pbfmt->biHeight * pbfmt->biWidth * 3;
	if (scl < 1 || scl > 9) {
		CopyMemory (obf,ibf,size+sizeof(BITMAPINFOHEADER));
		return size;
	}
	if (pbfmt->biCompression != BI_RGB) return 0;
	if (pbfmt->biBitCount != 24) return 0;

	CopyMemory (obf+sizeof(BITMAPINFOHEADER),ibf+sizeof(BITMAPINFOHEADER),sizeof(BITMAPINFOHEADER));
	iysize = pbfmt->biHeight ;
	ixsize = pbfmt->biWidth ;

	ixpt = ixsize / 2;
	iypt = iysize / 2;

	cxsize = (int) (floor((double) ixsize * scl/10.0));
	cysize = (int) (floor((double) iysize * scl/10.0));

	ixst = ixpt - (int) floor((cxsize / 2.0));
	ixed = ixpt + (int) floor((cxsize / 2.0));
	iyst = iypt - (int) floor((cysize / 2.0));
	iyed = iypt + (int) floor((cysize / 2.0));
	yl = (double) iysize / (double) cysize;
	xl = (double) ixsize / (double) cxsize;
	for (i=0;i<iysize;i++) {
		ypos = iyst + (int) floor(i/yl);
		for (j=0;j<ixsize;j++) {
			xpos = ixst + (int) floor(j/xl);
			pt =ipt+(xpos*3) + (ypos*ixsize*3);
			pirgb = (struct rgbtbl	*) pt;
			porgb->r =  pirgb->r;
			porgb->g =  pirgb->g;
			porgb->b =  pirgb->b;
			porgb++;
		}
	}
	
	
	return size;
}


static int Get_bmtfile (HWND hwnd,LPBITMAPINFOHEADER pvfmt,PBYTE pt,LPBYTE buf)
{

	int					rtcd;
	DWORD				size;
//*****   work
	int					i,j;
	DWORD				ln;
	int					ncol;
    int                 sz;

//************ ͗p
	HDC					in_hDC;
	BITMAP				in_bm;
	HBITMAP				in_hbmp;

//************ p
	RECT				wrect;
	HDC					mem_hDC;
	HBITMAP				mem_hbmp;


//***********  bitmap aria
    LPBYTE				to_hbit;
	LPBITMAPINFOHEADER	to_bithed;
	LPRGBQUAD			to_bitcol;
	DWORD	drwtime;
	DWORD	getbtime;
	PBYTE	drwtbl;
	BITMAPINFOHEADER	bfmt;
	PRGB32BITTBL		p32tbl;
	PRGB24BITTBL		p24tbl;
	PRGB16BITTBL		p16tbl;
	RGB24BITTBL		in24tbl;
	RGB24BITTBL		ot24tbl;

	in_hDC		=	GetDC (hwnd);
//	GetClientRect	  (hwnd,&rect);
	wrect.right  = pvfmt->biWidth ;
	wrect.bottom = pvfmt->biHeight ;
	wrect.left = 0;
	wrect.top  = 0;
	in_hbmp		=	CreateCompatibleBitmap (in_hDC,wrect.right,wrect.bottom);
	GetObject  (in_hbmp,sizeof(BITMAP),(LPSTR)&in_bm);

	mem_hDC		=	CreateCompatibleDC(in_hDC);
	SetMapMode (mem_hDC,GetMapMode (in_hDC));

	mem_hbmp =  (HBITMAP) SelectObject  (mem_hDC,in_hbmp);

	drwtime  = timeGetTime();
	DrawDibDraw (hdrawdibCvb,
				mem_hDC,
				wrect.left,
				wrect.top,
				wrect.right  - wrect.left,
				wrect.bottom - wrect.top,
				(LPBITMAPINFOHEADER) pvfmt,
				pt+sizeof(BITMAPINFOHEADER),
				0,0,-1,-1,0);
	drwtime  = timeGetTime() - drwtime;

	SelectObject  (mem_hDC,mem_hbmp);

	drwtbl = DrawDibGetBuffer(hdrawdibCvb, &bfmt,sizeof(BITMAPINFOHEADER),0); 

	to_hbit		= (LPBYTE)	buf + sizeof(BITMAPINFOHEADER);

	size = bfmt.biHeight * bfmt.biWidth * 3;
	if (drwtbl) {
		if (bfmt.biBitCount  == 32  && bfmt.biCompression == 0) {
		// convert 32-> 24
			p32tbl = (PRGB32BITTBL) drwtbl;
			p24tbl = (PRGB24BITTBL) to_hbit;
			for (i=0;i<bfmt.biHeight;i++) {
				for (j=0;j<bfmt.biWidth;j++) {
					p24tbl->r  = p32tbl->r;
					p24tbl->g  = p32tbl->g;
					p24tbl->b  = p32tbl->b;
					p24tbl++;
					p32tbl++;
				}
			}
		} else if (bfmt.biBitCount  == 24 && bfmt.biCompression == 0) {
			CopyMemory (to_hbit,drwtbl,size);
		} else if (bfmt.biBitCount  == 16 && bfmt.biCompression == 3) {
			WORD	r,g,b;

			p16tbl = (PRGB16BITTBL) drwtbl;
			p24tbl = (PRGB24BITTBL) to_hbit;
			for (i=0;i<bfmt.biHeight;i++) { 
				for (j=0;j<bfmt.biWidth;j++) { 
					b  = p16tbl->rgb & 0x001f;		// 5 bit
					g  = p16tbl->rgb & 0x07e0;		// 6 bit 
					r  = p16tbl->rgb & 0xf800;		// 5 bit
					in24tbl.b  = LOBYTE (b);			// 5 bit
					in24tbl.g  = LOBYTE (g >> 5);		// 6 bit 
					in24tbl.r  = LOBYTE (r >> 11);		// 5 bit

//					b  = p16tbl->rgb & 0x001f;		// 5 bit
//					g  = p16tbl->rgb & 0x03e0;		// 5 bit 
//					r  = p16tbl->rgb & 0x7c00;		// 5 bit
//					in24tbl.b  = LOBYTE (b);			// 5 bit
//					in24tbl.g  = LOBYTE (g >> 5);		// 5 bit 
//					in24tbl.r  = LOBYTE (r >> 10);		// 5 bit

					Conv16To24 (&in24tbl,&ot24tbl);
					p24tbl->r  = ot24tbl.r;
					p24tbl->g  = ot24tbl.g;
					p24tbl->b  = ot24tbl.b;
			
					p24tbl++;
					p16tbl++;
				}
			}
		
		} else {
			DeleteObject (in_hbmp);
			DeleteObject (mem_hbmp);
			DeleteDC	 (mem_hDC);
			ReleaseDC    (hwnd,in_hDC);
			size = 0;
			return size;
		}

		memset (buf,0,sizeof(BITMAPINFOHEADER));
		to_bithed	=	(LPBITMAPINFOHEADER) buf;
		to_bitcol	=	(LPRGBQUAD) (buf + sizeof(BITMAPINFOHEADER));

		to_bithed->biSize	=	sizeof(BITMAPINFOHEADER);
		to_bithed->biWidth	=	in_bm.bmWidth;
		to_bithed->biHeight	=	in_bm.bmHeight;
		to_bithed->biPlanes	=	1;
		to_bithed->biBitCount=	24;
		to_bithed->biCompression =	BI_RGB;
		to_bithed->biSizeImage = size;
	} else {
		ncol = in_bm.bmPlanes * in_bm.bmBitsPixel;
		if  (ncol <= 1) {
			ncol = 1;
			sz  = 1;
		}
		else if (ncol <= 4 ) {
			ncol = 4;
			sz  = 16;
		}
		else if (ncol <= 8 ) {
			ncol = 8;
			sz  = 256;
		}
		else {
			ncol = 24;
			sz  = 1024;
		}

		memset (buf,0,sizeof(BITMAPINFOHEADER));
		to_bithed	=	(LPBITMAPINFOHEADER) buf;
		to_bitcol	=	(LPRGBQUAD) buf + sizeof(BITMAPINFOHEADER);
		if (ncol == 24) {
			ln	=	0;
			to_hbit		= (LPBYTE)	buf + sizeof(BITMAPINFOHEADER);
		}
		else {
			ln 		=	(sz * sizeof(RGBQUAD));
			(LPBYTE)to_hbit		= (LPBYTE)buf + sizeof(BITMAPINFOHEADER) + (sz * sizeof(RGBQUAD));
		}

		to_bithed->biSize	=	sizeof(BITMAPINFOHEADER);

		to_bithed->biWidth	=	in_bm.bmWidth;
		to_bithed->biHeight	=	in_bm.bmHeight;

//		to_bithed->biPlanes	=	in_bm.bmPlanes;
		to_bithed->biPlanes	=	1;
//		to_bithed->biBitCount=	in_bm.bmBitsPixel;
		to_bithed->biBitCount=	ncol;
		to_bithed->biCompression =	BI_RGB;
		to_bithed->biSizeImage = size;

		getbtime  = timeGetTime();
  		rtcd = GetDIBits ( mem_hDC,in_hbmp,0,in_bm.bmHeight,
				to_hbit,
				(LPBITMAPINFO) to_bithed,
				DIB_RGB_COLORS);
		getbtime  = timeGetTime() - getbtime;
	}

	DeleteObject (in_hbmp);
	DeleteObject (mem_hbmp);
	DeleteDC	 (mem_hDC);
	ReleaseDC    (hwnd,in_hDC);
	size = to_bithed->biSizeImage;
	return size;

}

static void	Conv16To24 (PRGB24BITTBL intbl,PRGB24BITTBL ottbl)
{

	double  r,g,b;

	r = (double) intbl->r / 31.0;
	g = (double) intbl->g / 63.0;
	b = (double) intbl->b / 31.0;
	ottbl->r  = LOBYTE ((WORD)(255.0 * r));
	ottbl->g  = LOBYTE ((WORD)(255.0 * g));
	ottbl->b  = LOBYTE ((WORD)(255.0 * b));

}


void bitmap_conv(LPBITMAPINFOHEADER pfmt,PBYTE	ibf,PBYTE	obf,int scl) { /* rbg}bvɑ΂] */

	int		i,j,xx,yy;
	int		ixsize;
	int		bmpx,bmpy;
	int		bmpsz;
	double dscl;
	double	pai=3.141592654;
	double cos_dt;
	double sin_dt;
	
	/* rbg}bv̑傫ۑ */
	bmpx	=	pfmt->biWidth;
	bmpy	=	pfmt->biHeight;
	if (pfmt->biBitCount != 24) {
		return ;
	}
	if (scl == 18) {		// no convert
		bmpsz = bmpx * bmpy * 3;
		CopyMemory (obf,ibf,bmpsz);
		return ;
	} else if (scl < 18) {
		dscl = (double) ((18 - scl) * 10) * (pai / 180.0);
		dscl = -dscl;
	} else if (scl < 37) {
		dscl = (double) ((scl - 18) * 10) * (pai / 180.0);
	} else {
					// no convert
		bmpsz = bmpx * bmpy * 3;
		CopyMemory (obf,ibf,bmpsz);
		return ;
	}
	cos_dt = cos(dscl);
	sin_dt = sin(dscl);

	if ((bmpx*3) % 4==0) {/* obt@̂PC̒vZ */
		ixsize=bmpx * 3;
	} else {
		ixsize=bmpx * 3+(4-(bmpx*3) % 4);
	}
	
	FillMemory(obf,ixsize*bmpy,0xff);

	// dscl = -0.3 TEST

	for (i=0;i<bmpy;i++)  /* rbg}bv] */
		for (j=0;j<bmpx;j++) {

			/* ]̃sNZɑΉ]ÕsNZvZ */
			xx=(int)((j-bmpx/2)*cos_dt-(i-bmpy/2)*sin_dt)+bmpx/2;
			yy=(int)((j-bmpx/2)*sin_dt+(i-bmpy/2)*cos_dt)+bmpy/2;

			/* ]̃sNZɁAΉ]ÕsNZ` */
			if (xx>=0 && yy>=0 && xx<bmpx && yy<bmpy)
				CopyMemory(obf+j*3+i*ixsize,ibf+xx*3+yy*ixsize,3);

		}
}

